const {
  COMPONENT_TYPE,
  COMPONENT_RENDER_TYPE,
  COMPONENTS,
  SPECIAL_FIELDS,
} = require("./lib/component/components")
const { GLOBAL_TABLES } = require("./lib/Intelligence-analyse/table")
// const { PLUGINS, PLUGIN_GROUP } = require('./lib/base/plugins');
const { ROLE_TYPE, parseAccess } = require('./lib/form/form_access_parser');
const { parseConditionConfig, parseCondition } = require('./lib/form/form_condition_parser');
const { FormManager } = require('./lib/form/form_manager');
const TABLE_MAP = require('./lib/Intelligence-analyse/report/report');
const { parseDatasOrder } = require('./lib/form/form_data');

const iaParser = require('./lib/Intelligence-analyse/parse');

module.exports = {
  component: {
    COMPONENT_TYPE,
    COMPONENT_RENDER_TYPE,
    COMPONENTS,
    SPECIAL_FIELDS,
  },
  form: {
    ROLE_TYPE,
    parseAccess,
    parseConditionConfig,
    FormManager,
    parseCondition,
    parseDatasOrder,
  },
  GLOBAL_TABLES,
  TABLES: {
    ...TABLE_MAP,
  },
  report: {
    ...iaParser,
  },
}
