/**
{
  [UUID.SingleLineText]: [
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.MultilineText]: [
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.Mailbox]: [
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.Phone]: [
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.DropDownRadio]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.DropDownCheckBox]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.RadioButton]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
  ],
  [UUID.CheckBox]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
  ],
  [UUID.Number]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
    { label: '小于', value: '<' },
    { label: '大于', value: '>' },
    { label: '小于等于', value: '<=' },
    { label: '大于等于', value: '>=' },
    { label: '在范围内', value: 'between' },
    { label: '不在范围内', value: 'not_between' },
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.SingleDate]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
    { label: '早于', value: 'before' },
    { label: '晚于', value: 'after' },
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.RangeDate]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
    { label: '早于', value: 'before' },
    { label: '晚于', value: 'after' },
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.Member]: [
    { label: '等于', value: '=' },
    { label: '不等于', value: '!=' },
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
  [UUID.DividingLine]: [],
  [UUID.File]: [
    { label: '为空', value: 'be_null' },
    { label: '不为空', value: 'not_be_null' },
  ],
}
 */
/**
 * [
 *  [['f1', '=', 1], ['f2', '=', '3']],
 *  [['f1', '=', 1], ['f2', '=', '3']]
 * ]
 *
 * function () {
 *  return (f1 === 1 && f2 === 3) || (f1 === 1 && f2 === 3)
 * }
 * @param {*} item
 * @returns
 */

function isCondition (item = []) {
  return Array.isArray(item[0]);
}

function parseIf (form, cond, context) {
  const fieldMap = {};
  form.fields.forEach(field => {
    fieldMap[field.id] = field;
  });
  // field
  const fieldName = `${context.objName}.${cond[0]}`;
  // op
  let op = '';

  switch (cond[1]) {
    case '=': op = '==='; break;
    case '=': op = '==='; break;
    case '=': op = '==='; break;
  }
  // value
  let value = cond[2];
  const valueType = typeof value;

  if (valueType === 'string') {
    value = `'${value}'`
  }

  return `${fieldName} ${op} ${value}`;
}

function parseCondition (form, conditions = [], isOr = true, context) {
  if (!isCondition(conditions)) {
    return parseIf(form, conditions, context);
  }
  const list = [];
  conditions.forEach(cond => {
    const result = parseCondition(form, cond, !isOr, context);
    list.push(result);
  });
  return '(' + list.join(isOr ? ' || ' : ' && ') + ')';
}

/**
 *
 * @param {*} form: object 表单配置
 * @param {*} conditionConfig: Array 条件列表
 * @param {*} context = {
 *              roles: [ { id, type } ],
 *              objName : 'item', // 对象名称，比如'item'、'obj'、'user'
 *            }  上下文信息，如当前用户的角色列表等
 * @returns function (obj) { return obj.a === 1 || obj.c > 2; }
 *
 * const fn =
 *
 * list.filter(fn)
 *
 * list.filter(item => return item.a==1 && item.b==2)
 */
function parseConditionConfig (form, conditionConfig = [], context = { objName: '' }) {
  let result = '';
  result = parseCondition(form, conditionConfig, true, context);
  result = `return function (${context.objName}) { return ${result}; }`;
  // console.info(result);
  return (new Function(result))();
}

module.exports = {
  parseConditionConfig,
};
