const helper = require('../../helper');

const { COMPONENT_TYPE } = require('../../component/component_type');

const FormFieldManager = function () {

  var fieldslist, _formulafields, dictionaryTables, tableInfo, fieldsEnum, conditions, conditionsEnum;

  var analysisTableInfo = function () {
    if (!tableInfo.options) return;
    _formulafields = { fields: {}, names: {} };
    fieldslist = tableInfo.options.fields;
    conditions = tableInfo.options.conditions;
    fieldsEnum = {};
    conditionsEnum = {};
    var _get = function (_field, _tableId) {
      var key = _tableId == "main" ? _field.id : (_tableId + "." + _field.id),
        _preName = (_tableId == "main" ? "" : (fieldslist[_tableId].name + ".")) + _field.name;
      _formulafields.fields[key] = Object.assign(_field, {
        id: key,
        table: _tableId,
        name: _preName,
        vtype: _field.controlType == COMPONENT_TYPE.NUMBER ? "num" : _field.controlType == COMPONENT_TYPE.DATE ? "time" : "",
        isTableField: true
      });
      if (!_formulafields.names[_preName]
        || _formulafields.names[_preName] && (_field.controlType == COMPONENT_TYPE.NUMBER || _field.controlType == COMPONENT_TYPE.DATE))
        _formulafields.names[_preName] = key;

      if (_field.controlType === COMPONENT_TYPE.FOREIGN_REF && _field.valueSource) {
        var tempVisitedDT = {};
        var addDTField = function (_dtField, _dtTableId, _dtTableName, _dtTableId2) {
          var _name = _dtTableName + "." + _dtField.name;
          var _id = _dtTableId + "." + _dtField.id;
          var _id2 = _dtTableId2 + "." + _dtField.id;
          _formulafields.fields[_id] = Object.assign(_dtField, {
            id: _id,
            name: _name,
            vtype: _dtField.controlType == COMPONENT_TYPE.NUMBER ? "num" : "",
            table: _tableId,
            isTableField: false,
            refTableFieldId: (_tableId == "main" ? "" : (_tableId + ".")) + _field.id
          });
          _formulafields.fields[_id2] = Object.assign(_dtField, {
            id: _id2,
            name: _name,
            vtype: _dtField.controlType == COMPONENT_TYPE.NUMBER ? "num" : "",
            table: _tableId,
            isTableField: false,
            refTableFieldId: _field.id
          });
          /*
          _formulafields.fields[_id] = {
          id: _id,
          name: _name,
          vtype: _dtField.controlType == "number" ? "num" : "",
          table: _tableId,
          isTableField: false,
          controlType: _dtField.controlType
          };
          */
          _formulafields.names[_name] = _id;
          // if (_dtField.controlType == COMPONENT_TYPE.SELECT && _dtField.valueSource) {
          //   addDT(getDTFields(_dtField.valueSource), _name, _id, _id2);
          // }
        };

        var addDT = function (_dtFields, _name, _id, _extendId) {
          if (!_dtFields || tempVisitedDT[_dtFields.id]) return;
          tempVisitedDT[_dtFields.id] = 1;
          if (!_dtFields) return;
          _dtFields.options = typeof _dtFields.options == "string" ? JSON.parse(_dtFields.options) : _dtFields.options;
          for (var f in _dtFields.options.fields) {
            addDTField(_dtFields.options.fields[f], _id + ".s" + _dtFields.id, _name, _extendId + ".s" + _dtFields.id);
          }
        };

        addDT(getDTFields(_field.valueSource), _preName, (_tableId == "main" ? "" : (_tableId + ".")) + _field.id, _field.id);

      }
    }, f, cf;
    for (f in fieldslist) {
      cf = fieldslist[f];
      fieldsEnum[f] = cf;
      fieldsEnum[f].table = "main";
      _get(cf, "main");
      if (cf.controlType === COMPONENT_TYPE.CHILD_TABLE) {
        // const fields = todo 加子表
        for (var h in cf.fields) {
          fieldsEnum[h] = cf.fields[h];
          fieldsEnum[h].table = f;
          _get(cf.fields[h], f);
        }
      }
    }
  };

  var bindFields = function (_tableInfo) {
    tableInfo = _tableInfo;
    dictionaryTables = tableInfo.dictionaryTables || [];
    analysisTableInfo();
  };

  var getFormulaFieldInfo = function (id) {
    //return _formulafields.fields[id];
    return _formulafields.fields[id] ? Object.assign(_formulafields.fields[id], {
      getDTFields: getDTFields
    }) : null;
  };
  var getFormulaFieldInfoById = function (id) {
    return _formulafields.fields[id] ? _formulafields.fields[id] : null;
  };
  var getFormulaFieldInfoByName = function (name) {
    return _formulafields.names[name] ? _formulafields.fields[_formulafields.names[name]] : null;
  };
  var getFormulaFieldNameById = function (id) {
    return _formulafields.fields[id] ? _formulafields.fields[id].table == "main" ? _formulafields.fields[id].name
      : (_formulafields.fields[id].name) : "已删?";
  };
  var getFormulaFieldIdByName = function (name) {
    return _formulafields.names[name] || "";
  };
  var getFieldInfo = function (_id) {
    return fieldsEnum[_id];
  };
  var getDTFields = function (id) {
    function _get (_id) {
      if (!dictionaryTables) return null;
      var len = dictionaryTables.length, _table;
      for (var i = 0; i < len; i++) {
        var ci = dictionaryTables[i];
        if (ci.id != _id) continue;
        _table = ci;
        _table.dependTables = {};
        tempVisited[_id] = 1;
        _table.options = typeof _table.options == "string" ? JSON.parse(_table.options) : _table.options;
        for (var f in _table.options.fields) {
          var cf = _table.options.fields[f];
          if (!cf.valueSource || tempVisited[cf.valueSource]) continue;
          tempVisited[cf.valueSource] = 1;
          cf.sourceTable = _get(cf.valueSource);
          _table.dependTables[cf.valueSource] = 1;
        }
        break;
      }
      return _table;
    }
    var tempVisited = {};
    return _get(id);
  };
  var getRefTableFieldValue = function (_fieldIds, _fid, isGetId) {

    var dtId = _fieldIds[0].replace("s", ""), fieldId = _fieldIds[1], isFind = false;
    var opt = null;
    for (var i = 0; i < dictionaryTables.length; i++) {
      var ci = dictionaryTables[i];
      if (ci.id == dtId) {
        ci.options = typeof ci.options == "string" ? JSON.parse(ci.options) : ci.options;
        ci.items = typeof ci.items == "string" ? JSON.parse(ci.items) : ci.items;
        for (var j = 0; j < ci.items.length; j++) {
          var cj = ci.items[j];
          if ((ci.id == 2 || ci.id == 3) && cj["f1"] && cj["f1"]["id"] == _fid || cj["id"] == _fid) {
            _fid = cj[fieldId];
            opt = ci.options.fields[fieldId];
            isFind = true;
            break;
          }
        }
        break;
      }
    }
    if (!isFind) return "";
    _fieldIds.splice(0, 2);
    if (_fieldIds.length == 0) {
      if (isGetId === true) {
        return _fid;
      } else {
        if (opt && opt.controlType == 'select') {
          _fieldIds.push('s' + opt.valueSource, 'f1');
        } else {
          return _fid;
        }
      }

    }
    return getRefTableFieldValue(_fieldIds, _fid);
  };
  var getValueByControlType = function (_fieldInfo, _data, noHtml) {
    _data = _data == null ? "" : _data;
    switch (_fieldInfo.controlType) {
      case "weaksignature":
      case "user": return _data ? _data.name || _data : "";
      case "orgunit": return _data ? _data.path || _data.name || _data : "";
      case "date": return _data == "" ? "" : helper.Date.getDateByFormat(_data, _fieldInfo.dateFormat) || "";
      case "textarea": return _data ? noHtml ? _data : ("<br/>" + _data + "<br/>") : "";
      default: return _data == null ? "" : _data;
    }

  };
  var _model = {
    bindFields,
    getFormulaFieldInfo,
    getFormulaFieldNameById,
    getFormulaFieldIdByName,
    getFieldInfo,
    getDTFields,
    getRefTableFieldValue,
    getValueByControlType,
    getFormulaFieldInfoById,
    getFormulaFieldInfoByName,
    getTableInfo: function () {
      return tableInfo;
    },
    getTableFields: function () {
      return fieldslist;
    }
  };

  return _model;
};

module.exports = {
  FormFieldManager,
};
