
const { EOF_symbol, lex, _parse } = require('./formula_parser');
// const helper = require('./helper');
/*下面程序中:
  以se,sexpr为前缀的变量一律指字符串形式的表达式
  以pe,pexpr为前缀的变量一律指语法分析后的JSON形式的表达式
  以oe,oexpr为前缀的变量一律指为便于计算而优化后的JSON形式的表达式
*/
//浮点计算
//lib.formula_js
const floatcalculate = {
  //加法
  add: function (a, b) {
    var r1, r2, m, n;
    try { r1 = a.toString().split(".")[1].length } catch (e) { r1 = 0 }
    try { r2 = b.toString().split(".")[1].length } catch (e) { r2 = 0 }
    n = Math.max(r1, r2);
    m = Math.pow(10, n);
    return ((a * m + b * m) / m);
  },
  adds: function () {
    var paraLen = arguments.length;
    if (paraLen == 0) return 0;
    else if (paraLen == 1) return arguments[0];
    else if (paraLen >= 1) {
      var r = "(0", m, n = 0, ci, i;
      for (i = 0; i < paraLen; i++) {
        ci = arguments[i].toString();
        try { n = Math.max(n, ci.split(".")[1].length) } catch (e) { n = Math.max(n, 0) }
      }
      m = Math.pow(10, n);
      for (i = 0; i < paraLen; i++) {
        ci = arguments[i];
        r += "+" + ci + "*" + m;
        if (i == paraLen - 1) r += ")/" + m;
      }
      r = eval(r);
      return r;
    }
    return 0;
  },
  //减法
  sub: function (a, b) {
    var r1, r2, m, n;
    try { r1 = a.toString().split(".")[1].length } catch (e) { r1 = 0 }
    try { r2 = b.toString().split(".")[1].length } catch (e) { r2 = 0 }
    m = Math.pow(10, Math.max(r1, r2));
    n = (r1 >= r2) ? r1 : r2;
    return ((a * m - b * m) / m).toFixed(n);
  },
  //乘法
  mul: function (a, b) {
    var m = 0, s1 = a.toString(), s2 = b.toString();
    try { m += s1.split(".")[1].length } catch (e) { }
    try { m += s2.split(".")[1].length } catch (e) { }
    return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)
  },
  muls: function () {
    var paraLen = arguments.length;
    if (paraLen == 0) return 0;
    else if (paraLen == 1) return arguments[0];
    else if (paraLen >= 1) {

      var m = 0, r = "1", ci, i;
      for (i = 0; i < paraLen; i++) {
        ci = arguments[i].toString();
        try { m += ci.split(".")[1].length } catch (e) { }
      }
      for (i = 0; i < paraLen; i++) {
        ci = arguments[i].toString();
        r += '*' + Number(ci.replace(".", "")).toString();
        if (i == 1) r += "/Math.pow(10," + m + ")";
      }
      return eval(r);
    }
    return 0;
  },
  //除法
  div: function (a, b) {
    var t1 = 0, t2 = 0, r1, r2;
    try { t1 = a.toString().split(".")[1].length } catch (e) { }
    try { t2 = b.toString().split(".")[1].length } catch (e) { }
    with (Math) {
      r1 = Number(a.toString().replace(".", ""));
      r2 = Number(b.toString().replace(".", ""));
      return (r1 / r2) * pow(10, t2 - t1);
    }
  }
};

function CheckLex (sexpr) {
  var tokens = [], tok;
  var info = { offset: 0, src: sexpr, att: "" };
  var la = lex(info);
  var pa = 0; // 尚未匹配的左括号数
  while (la != EOF_symbol) {
    tok = info.att;
    var type = tok.type;
    if (type == "bad")
      return { pos: tok.pos + tok.len, err: "左边不正确的字符" };
    if (type == "(")
      ++pa;
    else if (type == ")") {
      if (pa <= 0)
        return { pos: tok.pos + 1, err: "左边的)缺少匹配的(" };
      --pa;
    }
    else if (type == "num") {
      if (!isFinite(tok.val))
        return { pos: tok.pos + tok.len, err: "左边的数值太大" };
    }
    tokens.push(tok);
    la = lex(info);
  }
  if (pa > 0)
    return { pos: tok.pos + tok.len, err: "缺少" + pa + "个)" };
  return tokens;
}

function MergeDepend (d1, d2) {
  if (!d2) return;
  var n1 = d1.length, n2 = d2.length, i1, i2;
  for (i2 = 0; i2 < n2; ++i2) {
    var v = d2[i2];
    for (i1 = 0; i1 < n1; ++i1) {
      if (d1[i1] == v)
        break;
    }
    if (i1 >= n1) {
      d1.push(v);
      ++n1;
    }
  }
}

function MergeExpr (op, pe1, pe2, getFieldInfo, tr) {
  var r1 = CheckExpr(pe1, getFieldInfo, tr);
  if (r1.err)
    return r1;
  var r2 = CheckExpr(pe2, getFieldInfo, tr);
  if (r2.err)
    return r2;

  if (r1.table == "main")
    r1.table = r2.table;
  else if (r2.table != "main" && r1.table != r2.table)
    return { pos: op.pos, err: "左右两边分别是根据不同子表的字段计算的，无法进行运算" };

  switch (op.type) {
    case '&':
    case "|":
      break;
    case '>=':
    case '<=':
    case '=':
    case '>':
    case '<':
    case '!=':
      if (pe1.type == pe2.type && pe1.type == 'ident') {
        var f1 = getFieldInfo(tr(pe1.val)), f2 = getFieldInfo(tr(pe2.val));
        if (f1.controlType != f2.controlType) {
          return { pos: op.pos, err: "两边字段类型不一致,不能参与比较运算" };
        }
      }

      if ((r1.vtype == "num" || r1.vtype == "time") && r1.vtype != r2.vtype && r2.vtype != 'string') {
        return { pos: op.pos, err: "左边不是数值类型,不能参与比较运算" };
      }
      if (r1.vtype == "string") {
        return { pos: op.pos, err: "左边不能是字符串常量，不能参与比较" };
      }
      r1.vtype = "num";
      break;
    case '*':
    case '/':
      if (r1.vtype != "num")
        return { pos: op.pos - 1, err: "左边不是数值类型,不能参与乘除运算" };
      if (r2.vtype != "num")
        return { pos: op.pos + 1, err: "右边不是数值类型,不能参与乘除运算" };
      break;

    case '-':
      if (r1.vtype == "time") {
        if (r2.vtype == "time")
          r1.vtype = "num";
        else if (r2.vtype != "num")
          return { pos: op.pos, err: "日期时间只能和日期时间或数值做减法" };
      }
      else {
        if (r1.vtype != "num")
          return { pos: op.pos - 1, err: "左边不是日期时间类型，也不是数值类型, 无法做减法" };
        if (r2.vtype != "num")
          return { pos: op.pos + 1, err: "右边不是数值类型, 无法和左边的数值做减法" };
      }
      break;

    case '+':
      if (r1.vtype == "time") {
        if (r2.vtype != "num")
          return { pos: op.pos + 1, err: "右边不是数值, 无法和左边的日期时间做加法" };
      }
      else {
        if (r1.vtype != "num")
          return { pos: op.pos - 1, err: "左边不是日期时间类型，也不是数值类型, 无法做加法" };
        if (r2.vtype != "num")
          return { pos: op.pos + 1, err: "右边不是数值类型, 无法和左边的数值做加法" };
      }
      break;

    default:
      return { pos: op.pos, err: "内部错误" };
  }

  MergeDepend(r1.depend, r2.depend);
  return r1;
}

/* 说明:
 grp: true表示是组统计函数, 没有或false表示是常规函数
 vtypes: 函数返回值以及参数类型数组, [0]是返回值类型, [1][2]...分别是第1,2,...个参数的类型
 code: js代码模板, $arg1$表示第一个参数 目前仅对组函数有效
 */
var funcs = {
  DATE_ADD: {
    title: "时间计算",
    isGroupFun: false,
    exprs: {
      "date,num,string": {
        vtype: "date",
        grp: false,
        fn (dateObj, num, type) {

          const date = new Date(dateString);
          const dateTime = date.getTime();
        }
      }
    }
  },
  SUM: {
    title: "合计",
    isGroupFun: true,
    exprs: {
      "num": {
        vtype: "num",
        grp: true,
        code: "var x=0,$i=0,xs=[];" +
          "for(;$i<$n;++$i)" +
          "xs.push($arg1$);" +
          "x=globalThis.Formula.floatcalculate.adds.apply(null,xs);" +
          "return x;"
      }
    }
  },
  AVG: {
    title: "平均值",
    isGroupFun: true,
    exprs: {
      "num": {
        vtype: "num",
        grp: true,
        code: "var x=0,$i=0,xs=[];" +
          "for(;$i<$n;++$i)" +
          "xs.push($arg1$);" +
          "x=globalThis.Formula.floatcalculate.adds.apply(null,xs);" +
          "return $i==0?0:globalThis.Formula.floatcalculate.div(x,$i);"
      }
    }
  },
  MAX: {
    title: "最大值",
    isGroupFun: true,
    exprs: {
      "num": {
        vtype: "num",
        grp: true,
        code: [
          "var n=undefined, $i=0;",
          "for(;$i<$n;$i++)",
          "n=n==undefined?$arg1$:Math.max(n, $arg1$);",
          "return n;"
        ].join("")
      },
      "time": {
        vtype: "time",
        grp: true,
        code: [
          "var n=undefined, $i=0;",
          "for(;$i<$n;$i++)if($arg1$)",
          "n=n==undefined?(new Date($arg1$)).valueOf():Math.max(n, (new Date($arg1$)).valueOf());",
          "return n!=null?new Date(n):'';"
        ].join("")
      }
    }
  },
  MIN: {
    title: "最小值",
    isGroupFun: true,
    exprs: {
      "num": {
        vtype: "num",
        grp: true,
        code: [
          "var n=undefined, $i=0;",
          "for(;$i<$n;$i++)",
          "n=n==undefined?$arg1$:Math.min(n, $arg1$);",
          "return n;"
        ].join("")
      },
      "time": {
        vtype: "time",
        grp: true,
        code: [
          "var n=undefined, $i=0;",
          "for(;$i<$n;$i++)if($arg1$)",
          "n=n==undefined?(new Date($arg1$)).valueOf():Math.min(n, (new Date($arg1$)).valueOf());",
          "return n!=null?new Date(n):'';"
        ].join("")
      }
    }
  },
  COUNT: {
    title: "计数",
    isGroupFun: true,
    exprs: {
      "num": {
        vtype: "num",
        grp: true,
        code: "return $n;"
      },
      "string": {
        vtype: "num",
        grp: true,
        code: "return $n;"
      },
      "time": {
        vtype: "num",
        grp: true,
        code: "return $n;"
      }
    }
  },
  IF: {
    title: "三目运算",
    exprs: {
      "num,num,num": { vtype: "num", grp: false, fn: function () { return arguments[0] ? arguments[1] : arguments[2]; } },
      "num,time,time": { vtype: "time", grp: false, fn: function () { return arguments[0] ? arguments[1] : arguments[2]; } },
      "num,string,string": { vtype: "string", grp: false, fn: function () { return arguments[0] ? arguments[1] : arguments[2]; } }
    }
  },
  CEIL: {
    title: "向上取整",
    exprs: { "num": { vtype: "num", grp: false, fn: function () { return Math.ceil(arguments[0]); } } }
  },
  FLOOR: {
    title: "向下取整",
    exprs: { "num": { vtype: "num", grp: false, fn: function () { return Math.floor(arguments[0]); } } }
  },
  ROUND: {
    title: "四舍五入",
    exprs: { "num": { vtype: "num", grp: false, fn: function () { return Math.round(arguments[0]); } } }
  },
  NOT: {
    title: "非",
    exprs: {
      "num": { vtype: "num", grp: false, fn: function () { return 1 - (arguments[0] ? 1 : 0); } },
      "time": { vtype: "time", grp: false, fn: function () { return 1 - (arguments[0] ? 1 : 0); } }
    }
  },
  ANY: {
    title: '匹配至少一个存在',
    exprs: {
      "num": {
        vtype: "num",
        grp: true,
        code: [
          "var n=0, $i=0;",
          "for(;$i<$n;++$i){",
          "if(!$arg1$){continue;}",
          "else{n=1;break;}",
          "}",
          "return n;"
        ].join("")
      },
      "time": {
        vtype: "time",
        grp: true,
        code: [
          "var n=0, $i=0;",
          "for(;$i<$n;++$i){",
          "if(!$arg1$){continue;}",
          "else{n=1;break;}",
          "}",
          "return n;"
        ].join("")
      }
    }
  }
};

function Vtype2name (vtype) {
  var types = {
    "num": "数值",
    "time": "时间日期",
    "string": "常量/字段值"
  };
  return types[vtype] || "未知";
}

function CheckFunc (pe, getFieldInfo, tr) {
  var op = pe[0];
  var fname = op.val.toUpperCase();
  var funcp = funcs[fname];
  if (!funcp)
    return { pos: op.pos + op.len, err: "不认识左边的函数'" + fname + "', 请检查拼写" };
  var n = pe.length;

  var funExprs = funcp.exprs, minParaLens = [], recordParaLens = {}, mathExprs;
  for (var e in funExprs) {
    var cParaLen = e.split(",").length;

    if (!recordParaLens[cParaLen]) minParaLens.push(cParaLen);
    recordParaLens[cParaLen] = 1;

    if (n - 1 == cParaLen) {
      mathExprs = e;
      break;
    }
  }

  if (!mathExprs)
    return { pos: op.pos + op.len, err: "左边函数" + fname + "的参数个数必须为" + minParaLens.join("或") + "个, 这里检测到" + (n - 1) + "个" };

  var r1, rs = [], rinfo = [];
  for (var i = 1; i < n; ++i) {
    r = CheckExpr(pe[i], getFieldInfo, tr);
    var _paras = mathExprs.split(",");
    if (r.err)
      return r;
    rinfo.push(r);
    if (_paras.length == 3 && r.vtype.length == 0) {
      rs.push('string');
    } else {
      rs.push(r.vtype);
    }

  }
  mathExprs = rs.join();
  if (!funExprs[mathExprs]) {
    var paras = [];
    for (var e in funExprs) {
      var ceParas = e.split(",");
      for (var j = 0; j < ceParas.length; j++) {
        ceParas[j] = Vtype2name(ceParas[j]);
      }
      paras.push("“" + ceParas.join() + "”");
    }
    return { pos: pe[0].pos + pe[0].len, err: "参数类型不对，函数需要的参数组合必须为" + paras.join("或") };
  }


  for (var i = 1; i < n; ++i) {
    r = rinfo[i - 1];
    if (i == 1)
      r1 = r;
    else {
      if (r1.table == "main")
        r1.table = r.table;
      else if (r.table != "main" && r1.table != r.table)
        return { pos: pe[i].pos + pe[i].len, err: "左边函数参数所属的子表与前面的参数所属的子表不一致, 无法共存于函数" + fname + "中" };
      MergeDepend(r1.depend, r.depend);
    }
  }
  if (funExprs[mathExprs].grp) {
    if (r1.table == "main")
      return { pos: op.pos + op.len, err: "左边函数是组统计函数，其参数必须是带有某子表字段的计算公式，但这里是主表字段、常数或已经是自动统计值" };
    r1.table = "main";
  }
  r1.mathFunName = mathExprs;
  op.mathFunName = mathExprs;
  r1.vtype = funExprs[mathExprs].vtype;
  return r1;
}

function CheckVar (v, getFieldInfo, tr) {
  var field = v.val;
  if (tr) field = tr(field);
  var info = getFieldInfo(field);
  if (!info)
    return { pos: v.pos + v.len, err: "不认识的字段'" + v.val + "'" };
  return { vtype: info.vtype, table: info.table, depend: [field] };
}

var identOpTypes = { "+": 1, "-": 1, "*": 1, "/": 1, ">": 1, "<": 1, "=": 1, ">=": 1, "<=": 1, "!=": 1, "&": 1, "|": 1 };

function CheckExpr (pe, getFieldInfo, tr) {
  if (pe instanceof Array) {
    var op = pe[0], optype = op.type;
    if (optype == '-' && pe.length == 2) {
      var r = CheckExpr(pe[1], getFieldInfo, tr);
      if (r.err || r.vtype == "num")
        return r;
      return { pos: op.pos, err: "左边的'-'不正确，因为右边不是数值" };
    }
    if (identOpTypes[optype])
      return MergeExpr(op, pe[1], pe[2], getFieldInfo, tr);
    if (optype == "ident")
      return CheckFunc(pe, getFieldInfo, tr);
  }
  else {
    var type = pe.type;
    if (type == "num")
      return { vtype: "num", table: "main", depend: [] };
    if (type == "ident")
      return CheckVar(pe, getFieldInfo, tr);
    if (type == "string")
      return { vtype: "string", table: "main", depend: [] };
  }
  return { pos: op.pos, err: "内部错误" };
}

function CheckSyntax (sexpr, getFieldInfo, tr) {
  var erroffsets = [];
  var errlookaheads = [];
  var r = _parse(sexpr, erroffsets, errlookaheads);
  if (r.nerr > 0)
    return { pos: erroffsets[0], err: "公式的格式有错误" };
  return CheckExpr(r.result, getFieldInfo, tr);
}

function TranslateToken (tok, tr) {
  var toktype = tok.type;
  if (toktype == "ident") {
    var fname = tok.val.toUpperCase();
    if (funcs[fname])
      return fname;
    if (tr)
      return tr(tok.val);
    return tok.val;
  }
  if (tok.val)
    return tok.val;
  return toktype;
}
var compare_opts = ',' + ['=', '>', '<', '>=', '<=', '!='].join(',') + ',';
var getPrevFieldToken = function (start, tokens, type) {
  var idx = start - 1;
  while (idx >= 0) {
    var ctok = tokens[idx];
    if (!type) {
      if (compare_opts.indexOf(',' + ctok.type + ',') >= 0) {
        return getPrevFieldToken(idx, tokens, 'ident');
      } else if (!ctok.val && ctok.type == '(') {
        idx--;
      } else {
        return null;
      }
    } else {
      if (ctok.type == type) {
        return ctok;
      } else if (ctok.type == ')') {
        idx--;
      } else {
        return null;
      }
    }
  }
  return null;
};

function preParseSexpr (sexpr, method, getFieldInfo, tr, pr) {
  //转义逻辑运算符
  var tokens = CheckLex(sexpr);
  if (tokens.err)
    return tokens;
  var newSexpr = '', newShortSexpr = '', i = 0, len = tokens.length, pt = null;
  var hasGroupFn = false;
  var getSelectedItem = function (opts, val, key) {
    var ret = null;
    for (var i = 0, l = opts.length; i < l; i++) {
      if (val == opts[i][key]) {
        ret = opts[i];
        break;
      }
    }
    return ret;
  };
  for (; i < len; i++) {
    var tok = tokens[i];
    if (tok.type == 'string') {
      pt = getPrevFieldToken(i, tokens);
      if (!pt) {
        return sexpr;
      }
      var _fieldId = method == 'parse' ? tr(pt.val) : pt.val,
        _fieldInfo = getFieldInfo(_fieldId),
        _controlType = _fieldInfo.controlType,
        str = null,
        sv = tok.val.replace(/^\"/g, '').replace(/\"$/g, '').replace(/^\'/g, '').replace(/\'$/g, '');
      newSexpr += str;
      newShortSexpr += str;
    } else if (tok.type == 'num') {
      newSexpr += tok.val;
      newShortSexpr += tok.val;
    } else if (tok.type == 'ident') {
      var _fnName = tok.val.toUpperCase(),
        _funcp = funcs[_fnName];
      if (!_funcp) {
        // newSexpr += method == 'parse' ? tok.val : tr(tok.val);
        newSexpr += tok.val;
        newShortSexpr += pr ? pr(tok.val) : tok.val;
      } else {
        newSexpr += _fnName;
        newShortSexpr += _fnName;
        if (_funcp.isGroupFun) hasGroupFn = true;
      }
    } else {
      newSexpr += tok.type;
      newShortSexpr += tok.type;
    }
  }
  return { newSexpr, newShortSexpr, hasGroupFn };

}

/*
pe返回的结构
第一种情况: 不是一个数组，代表一个字段名称或数值常量
字段名称{type:"ident", val:字段名称}
数组常量{type:"num", val:数值}

第二种情况: 数组
取负[{type:'-'}, pe1]
加[{type:'+'}, pe1, pe2]
减[{type:'-'}, pe1, pe2]
乘[{type:'*'}, pe1, pe2]
除[{type:'/'}, pe1, pe2]
函数调用[{type:'ident',val:函数名}, pe1, pe2, ...]
 */

//lib.formula_js
const parse = function (sexpr, getFieldInfo, tr, pr) {
  //对表达是进行预处理，遍历字段，查找比较运算符左右字段，对string类型字段根据比较运算符左侧的字段类型进行解析
  sexpr = sexpr.replace(/\sAND\s/g, '&').replace(/\sOR\s/g, '|');
  const { newSexpr, newShortSexpr, hasGroupFn } = preParseSexpr(sexpr, 'parse', getFieldInfo, tr, pr);
  sexpr = newSexpr;
  if (typeof sexpr == "object") {
    return sexpr;
  }
  var tokens = CheckLex(sexpr);
  if (tokens.err)
    return tokens;
  var r = CheckSyntax(sexpr, getFieldInfo, tr);
  if (r.err)
    return r;
  var n = tokens.length, s = "";
  for (var i = 0; i < n; ++i)
    s += TranslateToken(tokens[i], tr);
  r.sexpr = s;
  r.sShortExpr = newShortSexpr;
  r.hasGroupFn = hasGroupFn;
  return r;
};

const translate = function (sexpr, getFieldInfo, tr, pr) {
  const { newSexpr, newShortSexpr, hasGroupFn } = preParseSexpr(sexpr, 'translate', getFieldInfo, tr, pr);
  sexpr = newSexpr;
  if (typeof sexpr == "object") {
    return sexpr.err;
  }
  var s = "";
  var info = { offset: 0, src: sexpr, att: "" };
  var la = lex(info);
  while (la != EOF_symbol) {
    s += TranslateToken(info.att, tr);
    la = lex(info);
  }
  s = s.replace(/\&/g, ' AND ').replace(/\|/g, ' OR ');
  return { s, newShortSexpr, hasGroupFn };
};
//return null | ntree.result;
const parseFormulaStaStructure = function (sexpr) {
  var ntree = _parse(sexpr, [], []);
  return ntree.nerr == 0 ? ntree.result : null;
};

const Calculator = function (getFieldInfo, getFieldVal, getTableRowCount, getFieldIdByName, getFieldNameById) {
  this.getFieldInfo = getFieldInfo; // function(field)返回{vtype:"num"/"time", table:"main"/子表}
  this.getFieldVal = getFieldVal; // function(field, row)返回Number或Date型的值, row是从0开始的行号(仅对子表表达式有效)
  this.getTableRowCount = getTableRowCount; // function(table)返回子表的行数
  this.getFieldIdByName = getFieldIdByName;
  this.getFieldNameById = getFieldNameById;
  this.clear();
};

var ERR_formula = "自动计算值公式有错误请打开表单编辑器修改";

var op_compare_expr = {
  ">": ">",
  ">=": ">=",
  "<": "<",
  "<=": "<=",
  "=": "==",
  "!=": "!=",
  "&": "&&",
  "|": "||"
};

var OP_FIELD = 1, // 字段变量
  OP_ADD = 2, // 加法
  OP_MULT = 3, // 乘法
  OP_GRPFUNC = 4, // 组函数:sum/avg/max/min等
  OP_FUNC = 5, // 普通函数
  OP_TIME_NUMBER = 6, // 时间加数值
  OP_TIME_TIME = 7, // 时间减时间
  OP_EXPR = 8, // 引用公共表达式
  OP_COMPARE_TIME = 9, // 条件运算
  OP_COMPARE_NUMBER = 10, // 条件运算
  OP_LOGICAL = 11, // 逻辑运算
  OP_STRING = 12, //字符串常量
  OP_COMPARE_STRING = 13,
  OP_COMPARE_COMPLEX = 14,
  OP_NUM = 0; // 常量

/* 优化过的表达式对象, 可能有如下属性:
  * op: 运算符, 参见前面的OP_xxx
  * table: "main"表示主表, 其它表示子表名称
  * vtype: 值类型
  * val: 对于OP_NUM表示数值的float表示
         对于OP_FIELD是字段名
         对于OP_ADD/OP_MULT/OP_GRPFUNC/OP_FUNC是[值表达式1, ...], 其中的每个值表达式都是一个优化过的表达式对象, 下同
         对于OP_EXPR是公共子表达式编号
         对其它运算无效
  * val1, val2: 对于OP_TIME_NUMBER和OP_TIME_TIME是值表达式1和值表达式2, 对其它运算无效
  * fname: 对于OP_GRPFUNC/OP_FUNC是函数名, 对其它运算无效
  * rowDepend: 本行值依赖的字段列表, 当table=="main"时无效, 可以是undefined或者是空数组
  * allDepend: 所有行值依赖的字段列表, 可以是undefined或者是空数组
  * neg: 为true表示取相反数, OP_NUM和(OP_ADD且!inv)上的neg应该始终是false或未定义
  * inv: 为true表示取倒数, OP_NUM和OP_MULT上的inv应该始终是false或未定义
  *
  * 对于OP_MULT的特别规定:
  * 常量因子必须出现在val[0], 且必须是非负数
  * 所有因子的neg属性必须为false或未定义
  *
  * 对于OP_ADD的特别规定:
  * 常量求和项必须出现在val[0]
*/

var getParaStr = function (_val) {
  var _str;
  if (_val.op == OP_NUM) _str = "(" + _val.val + ")";
  else if (_val.op == OP_STRING) _str = "(String('" + _val.val + "'))";
  else if (_val.op == OP_FIELD) _str = "($p.f('" + _val.val + "'" + (",typeof $i==undefined?0:$i") + "))";
  else if (_val.op == OP_EXPR) _str = "($p.e[" + _val.val + "])";
  else if (_val.op == OP_MULT || _val.op == OP_ADD || _val.op == OP_GRPFUNC || _val.op == OP_FUNC) _str = Oexpr2Str(_val);
  else if (_val.op == OP_TIME_TIME) {
    var _para1 = getParaStr(_val.val1);
    var _para2 = getParaStr(_val.val2);
    _str = "(" + _para1 + "&&" + _para2 + "?(((" + getTimeStr(getParaStr(_val.val1)) + "-" + getTimeStr(getParaStr(_val.val2)) + ")/1000/60/60/24)||0):0)";
  } else if (_val.op == OP_TIME_NUMBER) {
    var _para = getParaStr(_val.val1);
    _str = "(" + _para + "?new Date(" + getTimeStr(_para) + "+(" + getTimeStrByDays(getParaStr(_val.val2)) + "||0)):\"\")";
  } else if (_val.op == OP_COMPARE_NUMBER) {
    _str = "(((" + getParaStr(_val.val1) + ")" + op_compare_expr[_val.type] + "(" + getParaStr(_val.val2) + "))?1:0)";
  } else if (_val.op == OP_COMPARE_TIME) {
    _str = "(((" + getTimeStr(getParaStr(_val.val1)) + ")" + op_compare_expr[_val.type] + "(" + getTimeStr(getParaStr(_val.val2)) + "))?1:0)";
  } else if (_val.op == OP_LOGICAL) {
    _str = "(((" + getParaStr(_val.val1) + ")" + op_compare_expr[_val.type] + "(" + getParaStr(_val.val2) + "))?1:0)";
  } else if (_val.op == OP_COMPARE_STRING) {
    _str = "(((" + getParaStr(_val.val1) + ")" + op_compare_expr[_val.type] + "(" + getParaStr(_val.val2) + "))?1:0)";
  }

  if (!_str) throw ERR_formula;
  if (_val.neg) {
    _str = "(-" + _str + ")";
  }
  if (_val.inv) {
    _str = "(1/" + _str + ")";
    //_str = "(Entos.Formula.floatcalculate.div(1, " + _str + "))";
  }
  return _str;
};

var getTimeStr = function (_timeStr) {
  _timeStr = _timeStr || "";
  if (_timeStr)
    return "(new Date(" + _timeStr + ").getTime())";
  return _timeStr;
};

var getTimeStrByDays = function (_days) {
  _days = _days || 0;
  return "(" + _days + "*24*60*60*1000" + ")";
};

function Oexpr2Str (oe) {
  if (oe.str) return oe.str;
  // generate
  var str = "(", val = oe.val, op = oe.op;

  if (op == OP_NUM || op == OP_STRING || op == OP_FIELD || op == OP_EXPR) str += getParaStr(oe);
  else if (op == OP_ADD || op == OP_MULT) {
    var _opStr = op == OP_ADD ? "+" : "*";
    str += "globalThis.Formula.floatcalculate." + (op == OP_ADD ? "adds" : "muls");
    str += "(";
    for (var i = 0; i < val.length; i++) {
      str += getParaStr(val[i]);
      if (i != val.length - 1) str += ",";
    }
    str += ")";
  }
  else if (op == OP_GRPFUNC) {
    str += "$" + oe.fname + getParaStr(val[0]);
  } else if (op == OP_FUNC) {
    str += "$p.fn." + oe.fname + ".exprs['" + oe.mathFunName + "'].fn(";
    for (var i = 0; i < val.length; i++) {
      str += getParaStr(val[i]);
      if (i != val.length - 1) str += ",";
    }
    str += ")";
  } else if (op == OP_TIME_TIME
    || op == OP_TIME_NUMBER
    || op == OP_COMPARE_TIME
    || op == OP_COMPARE_NUMBER
    || op == OP_LOGICAL
    || op == OP_COMPARE_STRING) {
    str += getParaStr(oe);
  }

  str += ")";
  oe.str = str;
  return str;
}

function Oexpr2Func (oe) {
  var val = oe.val, op = oe.op, _fun;
  if (op == OP_GRPFUNC) {
    _fun = [
      "function($p, $n){",
      funcs[oe.fname].exprs[oe.mathFunName].code.replace(/\$arg1\$/g, oe.str.replace("$" + oe.fname, "")),
      "}"
    ].join("");
  } else {
    _fun = [
      "function($p, $i){",
      "return " + oe.str,
      ";",
      "}"
    ].join("");
  }
  _fun = new Function("return " + _fun + ";");
  return _fun();
}

function AddTrig (trigs, depend, eidx) {
  if (!depend) return;
  var n = depend.length, trig, field;
  for (var i = 0; i < n; ++i) {
    field = depend[i];
    trig = trigs[field];
    if (trig == undefined)
      trigs[field] = [eidx];
    else
      trig.push(eidx);
  }
}

function Neg (oe) {
  if (oe.neg)
    delete oe.neg;
  else if (oe.op == OP_ADD) {
    if (oe.inv)
      oe.neg = true;
    else {
      var n = oe.val.length;
      for (var i = 0; i < n; ++i)
        Neg(oe.val[i]);
    }
  }
  else if (oe.op == OP_NUM)
    oe.val = -oe.val;
  else
    oe.neg = true;
}

function Inv (oe) {
  if (oe.inv)
    delete oe.inv;
  else if (oe.op == OP_MULT) {
    var n = oe.val.length;
    for (var i = 0; i < n; ++i)
      Inv(oe.val[i]);
  }
  else if (oe.op == OP_NUM) {
    oe.val = 1 / oe.val;
    if (!isFinite(oe.val))
      throw ERR_formula;
  }
  else
    oe.inv = true;
}

function IsOexprLessThan (oe1, oe2) {
  var _s1 = Oexpr2Str(oe1), _s2 = Oexpr2Str(oe2);
  return oe1.op == OP_NUM ? true : oe2.op == OP_NUM ? false : _s1 < _s2;
}

function OptimizeAddMult (op, oe1, oe2) {
  var table, isMult = false, b1, b2;
  if (oe1.table == "main")
    table = oe2.table;
  else if (oe2.table == "main" || oe1.table == oe2.table)
    table = oe1.table;
  else
    throw ERR_formula;

  var rowDepend, allDepend;
  if (oe1.rowDepend) {
    rowDepend = oe1.rowDepend;
    MergeDepend(rowDepend, oe2.rowDepend);
  }
  else
    rowDepend = oe2.rowDepend;
  if (oe1.allDepend) {
    allDepend = oe1.allDepend;
    MergeDepend(allDepend, oe2.allDepend);
  }
  else
    allDepend = oe2.allDepend;
  delete oe1.rowDepend;
  delete oe1.allDepend;
  delete oe2.rowDepend;
  delete oe2.allDepend;

  switch (op.type) {
    case '&':
    case '|':
      return { op: OP_LOGICAL, type: op.type, table: table, vtype: "num", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
      break;
    case '>':
    case '<':
    case '>=':
    case '<=':
    case '=':
    case '!=':
      var isBaseVType = function (oe) {
        var str = ',' + ['num', 'time', 'string'].join(',') + ',';
        return str.indexOf(',' + oe.vtype + ',') >= 0;
      };
      if (oe1.vtype == oe2.vtype && isBaseVType(oe1)) {
        var _op = oe1.vtype == 'num' ? OP_COMPARE_NUMBER : (oe1.vtype == 'time' ? OP_COMPARE_TIME : OP_COMPARE_STRING);
        return { op: _op, type: op.type, table: table, vtype: "num", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
      } else if (oe1.vtype != oe2.vtype && oe2.vtype == 'string') {
        var _fieldInfo = this.getFieldInfo(oe1.val),
          _controlType = _fieldInfo.controlType;
        if (_controlType == 'date') {
          return { op: OP_COMPARE_TIME, type: op.type, table: table, vtype: "num", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
        } else if (_controlType == "textbox" || _controlType == "textarea") {
          return { op: isNaN(oe2.val) ? OP_COMPARE_STRING : OP_COMPARE_NUMBER, type: op.type, table: table, vtype: "num", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
        } else {
          return { op: OP_COMPARE_STRING, type: op.type, table: table, vtype: "num", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
        }
      } else {
        throw ERR_formula;
      }

      break;
    case '/':
      Inv(oe2);
    case '*':
      if (oe1.vtype != "num" || oe2.vtype != "num")
        throw ERR_formula;
      if (oe1.op == OP_NUM && oe2.op == OP_NUM) return { op: OP_NUM, table: "main", vtype: "num", val: oe1.val * oe2.val };
      b1 = (oe1.op == OP_MULT);
      b2 = (oe2.op == OP_MULT);
      isMult = true;
      break;

    case '-':
      if (oe1.vtype == "time" && oe2.vtype == "time")
        return { op: OP_TIME_TIME, table: table, vtype: "num", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
      Neg(oe2);
    case '+':
      if (oe1.vtype == "time") {
        if (oe2.vtype != "num")
          throw ERR_formula;
        return { op: OP_TIME_NUMBER, table: table, vtype: "time", val1: oe1, val2: oe2, rowDepend: rowDepend, allDepend: allDepend };
      }
      if (oe1.vtype != "num" || oe2.vtype != "num")
        throw ERR_formula;
      if (oe1.op == OP_NUM && oe2.op == OP_NUM) return { op: OP_NUM, table: "main", vtype: "num", val: oe1.val + oe2.val };
      b1 = (oe1.op == OP_ADD && !oe1.inv);
      b2 = (oe2.op == OP_ADD && !oe1.inv);
      break;

    default:
      throw ERR_formula;
  }

  if (b1 && b2) {
    var k1 = oe1.val[0].op == OP_NUM ? oe1.val.shift() : null;
    var k2 = oe2.val[0].op == OP_NUM ? oe2.val.shift() : null;
    var k;
    if (k1 == null)
      k = k2;
    else if (k2 == null)
      k = k1;
    else
      k = { op: OP_NUM, table: "main", vtype: "num", val: (isMult ? k1.val * k2.val : k1.val + k2.val) };
    if (isMult && k && k.val == 0) return k;

    var _newArray = oe1.val.concat(oe2.val);
    _newArray.sort(function (a, b) { return !IsOexprLessThan(a, b); });
    if (k) _newArray.unshift(k);
    return { op: oe1.op, table: table, vtype: "num", val: _newArray, rowDepend: rowDepend, allDepend: allDepend };
  }

  if (!b1) {
    if (!b2) { // 左右运算项不是加或减
      var neg, op, oe;
      if (isMult) {
        var reduce = function (oek) { // 对常量乘法优化乘以0, 1, -1这三种情况, 并保证各参与乘法的常量必须是非负数
          var k = oek.val;
          if (k == 0) return oe = oek;
          if (k == 1 || k == -1) { oe.rowDepend = rowDepend; oe.allDepend = allDepend; if (k == -1) Neg(oe); return oe; }
          if (k < 0) { oek.neg = true; oek.val = -k; }
        };
        if (oe1.op == OP_NUM) {
          oe = oe2;
          if (reduce(oe1)) return oe;
        }
        if (oe2.op == OP_NUM) {
          oe = oe1;
          if (reduce(oe2)) return oe;
        }
        neg = ((oe1.neg && !oe2.neg) || (!oe1.neg && oe2.neg));
        delete oe1.neg;
        delete oe2.neg;
        op = OP_MULT;
      }
      else { // 优化加上常量0的情况
        if (oe1.op == OP_NUM && oe1.val == 0) { oe2.rowDepend = rowDepend; oe2.allDepend = allDepend; return oe2; }
        if (oe2.op == OP_NUM && oe2.val == 0) { oe1.rowDepend = rowDepend; oe1.allDepend = allDepend; return oe1; }
        neg = false;
        op = OP_ADD;
      }
      return { op: op, table: table, vtype: "num", val: (IsOexprLessThan(oe1, oe2) ? [oe1, oe2] : [oe2, oe1]), rowDepend: rowDepend, allDepend: allDepend, neg: neg };
    }

    var t = oe1; oe1 = oe2; oe2 = t; // 交换oe1和oe2, 保证oe1.op是加法或乘法
  }

  if (oe2.op != OP_NUM) {
    //InsertVal(oe1.val, oe2);
    oe1.val.push(oe2);
    oe1.val.sort(function (a, b) { return !IsOexprLessThan(a, b); });
  }
  else {
    var k = oe2.val, done = false, oe1_has_const = false;
    var v = oe1.val[0];
    if (v.op == OP_NUM) {
      if (isMult)
        k *= v.val;
      else
        k += v.val;
      oe1_has_const = true;
    }

    if (k == 0) {
      if (isMult) return { op: OP_NUM, table: "main", vtype: "num", val: 0 }; // 任何表达式乘以0一定是0
      done = true; // 任何表达式加上0一定等于原表达式
    }
    else if (isMult && (k == 1 || k == -1)) {
      if (k == -1) Neg(oe1);
      done = true; // 任何表达式乘以1一定等于原表达式
    }

    if (done) {
      if (oe1_has_const) oe1.val.shift();
    }
    else {
      if (isMult && k < 0) { Neg(oe1); k = -k; }
      if (oe1_has_const)
        v.val = k;
      else
        oe1.val.unshift({ op: OP_NUM, table: "main", vtype: "num", val: k });
    }
  }

  oe1.rowDepend = rowDepend;
  oe1.allDepend = allDepend;
  oe1.table = table;
  return oe1;
}

Calculator.prototype = {
  clear: function () {
    this.s2oexpr = {}; // 从表达式字符串映射到this.oexprs的下标, 用于发现公共子表达式
    var oexprs = this.oexprs = []; /* 元素的结构: {ids:表达式id数组([]表示内部表达式),
                                      f:计算函数($f,$e,$i), // $i:table!="main"时是当前行号, 否则grptable!=null时是子表行数, 否则无效
                                      table:"main"/子表, grptable:组统计表达式所用的子表}*/
    this.oexpr_vals = []; // oexprs对应的表达式当前计算值, 仅对table=="main"的表达式有效
    this.fieldRowTrigs = {}; // 从字段映射到该字段改变时影响的本子表本行内表达式编号数组(按从小到大排序)
    this.fieldAllTrigs = {}; // 从字段映射到该字段改变时影响的所有行表达式编号数组(按从小到大排序)
    this.fieldDepends = {}; //字段的依赖关系 f1:[f2,f3] f1依赖f2、f3
    this.addExprState = {};
    this.exprs = {};
  },
  findWhoDepend: function (_id) {
    var ids = [];
    for (var e in this.fieldDepends) {
      if (this.findSameDepend(this.fieldDepends[e], _id)) ids.push(e);
    }
    return ids;
  },
  findSameDepend: function (_whos, _dependWho) {
    var isSame = false;
    for (var i = 0, j = _whos.length; i < j; i++) {
      var ci = _whos[i], ciDepends = this.fieldDepends[ci];
      if (ci == _dependWho) {
        isSame = true;
        break;
      }
      if (!ciDepends) continue;
      isSame = this.findSameDepend(ciDepends, _dependWho);
      if (isSame) break;
    }

    return isSame;
  },
  addExpr: function (id, sexpr) {
    if (this.fieldDepends[id]) return this.exprs[id];
    if (this.addExprState[id]) return;
    var r = _parse(sexpr, [], []);
    var r1 = parse(translate(sexpr, this.getFieldInfo, this.getFieldNameById), this.getFieldInfo, this.getFieldIdByName);
    if (r.nerr > 0 || r1.err) {
      console.error(r1.err);
      throw ERR_formula;
    }

    if (this.findSameDepend(r1.depend, id)) return;
    this.fieldDepends[id] = r1.depend;
    this.addExprState[id] = 1;
    var oe = this._optimizeExpr(r.result), idx;
    if (typeof (oe) == "number")
      idx = oe;
    else
      idx = this._addExpr(oe);
    this.oexprs[idx].ids.push(id);
    this.exprs[id] = idx;
    return idx;
  },

  calc: function (onResult = function () { }) { // function onResult(id, val, table, row): id-表达式id, val-表达式的值, table-"main"/子表, row-子表的当前行号(从0算起)
    var n = this.oexprs.length;
    for (var i = 0; i < n; ++i)
      this._calcExpr(i, onResult);
  },

  recalc: function (field, row, onResult) {
    var trigs = this.fieldRowTrigs[field], n, i;
    if (trigs) {
      n = trigs.length;
      for (i = 0; i < n; ++i) {
        var oe = this.oexprs[trigs[i]], ids = oe.ids, nIds = ids.length, table = oe.table;
        var val = oe.f({ f: this.getFieldVal, e: this.oexpr_vals, fn: funcs }, row);
        for (var k = 0; k < nIds; ++k)
          onResult(ids[k], val, table, row);
      }
    }
    trigs = this.fieldAllTrigs[field];
    if (!trigs) return;
    n = trigs.length;
    for (i = 0; i < n; ++i)
      this._calcExpr(trigs[i], onResult);
  },

  _addExpr: function (oe) {
    var str = Oexpr2Str(oe);
    var idx = this.s2oexpr[str];
    if (idx == undefined) {
      this.s2oexpr[str] = idx = this.oexprs.push({ f: Oexpr2Func(oe), ids: [], table: oe.table, grptable: oe.grptable, vtype: oe.vtype, rowDepend: oe.rowDepend, allDepend: oe.allDepend }) - 1;
      AddTrig(this.fieldRowTrigs, oe.rowDepend, idx);
      AddTrig(this.fieldAllTrigs, oe.allDepend, idx);
    }
    return idx;
  },

  _calcExpr: function (idx, onResult = function () { }) {
    var oe = this.oexprs[idx];
    var table = oe.table;
    var f = oe.f;
    var ids = oe.ids, nIds = ids.length, k, val;
    if (table == "main") {
      var grptable = oe.grptable;
      if (grptable)
        val = f({ f: this.getFieldVal, e: this.oexpr_vals, fn: funcs }, this.getTableRowCount(grptable));
      else
        val = f({ f: this.getFieldVal, e: this.oexpr_vals, fn: funcs });
      this.oexpr_vals[idx] = val;
      for (k = 0; k < nIds; ++k)
        onResult(ids[k], val, table);
    }
    else {
      var n = this.getTableRowCount(table);
      for (var i = 0; i < n; ++i) {
        val = f({ f: this.getFieldVal, e: this.oexpr_vals, fn: funcs }, i);
        for (k = 0; k < nIds; ++k)
          onResult(ids[k], val, table, i);
      }
    }
  },

  _optimizeExpr: function (pe) {
    if (pe instanceof Array) {
      var op = pe[0].type;
      if (op == '-' && pe.length == 2) {
        var e1 = this._getExprObj(this._optimizeExpr(pe[1]));
        Neg(e1);
        return e1;
      }
      if (op == 'ident')
        return this._optimizeFunc(pe);
      //return OptimizeAddMult(pe[0], this._getExprObj(this._optimizeExpr(pe[1])), this._getExprObj(this._optimizeExpr(pe[2])));
      return OptimizeAddMult.apply(this, [pe[0], this._getExprObj(this._optimizeExpr(pe[1])), this._getExprObj(this._optimizeExpr(pe[2]))])
    }

    var type = pe.type;
    var str = pe.val;
    if (type == "string") {
      return { op: OP_STRING, table: "main", vtype: "string", val: str.replace(/\"/g, '').replace(/\'/g, '') };
    }
    if (type == "num")
      return { op: OP_NUM, table: "main", vtype: "num", val: parseFloat(str) };
    if (type == "ident") {
      var info = this.getFieldInfo(str);
      if (!info)
        throw ERR_formula;
      if (info.expr) {
        this.addExpr(str, info.expr);
      }
      var table = info.table;
      if (table == "main")
        return { op: OP_FIELD, table: table, vtype: info.vtype, val: str, allDepend: [str] };
      return { op: OP_FIELD, table: table, vtype: info.vtype, val: str, rowDepend: [str] };
    }
    throw ERR_formula;
  },

  _getExprObj: function (oe) {
    if (typeof (oe) == "number") {
      var oe1 = this.oexprs[oe];
      return { op: OP_EXPR, table: oe1.table, vtype: oe1.vtype, val: oe, allDepend: oe1.allDepend };
    }
    return oe;
  },
  _optimizeFunc: function (pe) {
    var op = pe[0];
    var fname = op.val.toUpperCase();
    var funcp = funcs[fname];
    if (!funcp)
      throw ERR_formula;
    var n = pe.length;

    var funExprs = funcp.exprs, minParaLens = [], recordParaLens = {}, mathExprs;
    for (var e in funExprs) {
      var cParaLen = e.split(",").length;

      if (!recordParaLens[cParaLen]) minParaLens.push(cParaLen);
      recordParaLens[cParaLen] = 1;

      if (n - 1 == cParaLen) {
        mathExprs = e;
        break;
      }
    }

    if (!mathExprs)
      throw ERR_formula;

    var r1, r, rs = [], rinfo = [];
    for (var i = 1; i < n; ++i) {
      r = this._optimizeExpr(pe[i]);
      if (r.err)
        return r;

      rinfo.push(r);
      if (typeof r == "number") {
        r = this.oexprs[r];
      }
      rs.push(r.vtype);
    }
    mathExprs = rs.join();
    if (!funExprs[mathExprs]) {
      throw ERR_formula;
    }


    var oen, table = "main", rowDepend = null, allDepend = null, val = [], refNum;
    for (var i = 1; i < n; ++i) {
      oen = rinfo[i - 1];
      refNum = null;
      if (typeof oen == "number") {
        refNum = oen;
        oen = this.oexprs[refNum];
      }
      if (i == 1) {
        table = oen.table;
        rowDepend = oen.rowDepend;
        allDepend = oen.allDepend;
      }
      else {
        if (table == "main")
          table = oen.table;
        else if (oen.table != "main" && table != oen.table)
          throw ERR_formula;
        if (rowDepend)
          MergeDepend(rowDepend, oen.rowDepend);
        else
          rowDepend = oen.rowDepend;
        if (allDepend)
          MergeDepend(allDepend, oen.allDepend);
        else
          allDepend = oen.allDepend;
      }
      delete oen.rowDepend;
      delete oen.allDepend;
      if (refNum != null) {
        val.push({ op: OP_EXPR, val: refNum, vtype: oen.vtype, table: oen.table });
      } else {
        val.push(oen);
      }
    }

    if (!funExprs[mathExprs].grp)
      return { op: OP_FUNC, table: table, vtype: funExprs[mathExprs].vtype, val: val, fname: fname, mathFunName: mathExprs, rowDepend: rowDepend, allDepend: allDepend };

    if (table == "main")
      throw ERR_formula;
    if (allDepend)
      MergeDepend(allDepend, rowDepend);
    else
      allDepend = rowDepend;
    return this._addExpr({ op: OP_GRPFUNC, table: "main", vtype: funExprs[mathExprs].vtype, val: val, fname: fname, mathFunName: mathExprs, allDepend: allDepend, grptable: table });
  }
};

globalThis.Formula = {
  floatcalculate,
};

module.exports = {
  floatcalculate,
  Calculator,
  parse,
  translate,
  CheckLex,
  parseFormulaStaStructure,
};
