const { Calculator, translate, parse, parseFormulaStaStructure } = require('./lib/formula_main');
var MathFormulaManager = function (cfg) {
  var config = Object.assign({
    title: "编辑自动计算值",
    afterChange: function () { },
    onCalcChange: null,
    emptyExpr: false,
    canEditCondition: false,
    onConditionChange: function () {

    },
    showMode: "edit"
  }, cfg);

  var fieldslist, _window, hasTimeField, cformula, formulaOps, _formFieldsManager, _calculator, domtxt_formula, _cursorPosition;
  var $window, $txt_name, $txt_formula, $fields, $otherFields, $hid_formula_id, $calcoperator, $calcoperators, $formulaerror, $rule, $errortip, $calcoperatorsUl;
  var conditions, tableInfo, fieldTplTemplate;

  var init = function () {
    hasTimeField = false;
    _formFieldsManager = config.fieldsManager;

    _calculator = new Calculator(function (_id) {
      var info = _formFieldsManager.getFormulaFieldInfo(_id);
      if (formulaOps && formulaOps.exprs && formulaOps.exprs[_id]) {
        info.expr = formulaOps.exprs[_id].expr;
      }
      return info;
    }, function () {
      var _fieldInfo = _formFieldsManager.getFormulaFieldInfo(arguments[0]);
      var _val = config.getFieldData.apply(null, [arguments[0], arguments[1]]);
      var _cmpFieldInfo = !arguments[2] ? null : _formFieldsManager.getFormulaFieldInfo(arguments[2]);
      var getSelectedItemById = function (opts, id) {
        var ret = null;
        for (var i = 0, l = opts.length; i < l; i++) {
          if (id == opts[i].id) {
            ret = opts[i];
            break;
          }
        }
        return ret;
      };
      if (!_cmpFieldInfo) {
        return _fieldInfo.controlType == "number" ? Number(_val || 0) : _val == null ? "" : _val;
      } else {
        var _controlType = _fieldInfo.controlType;
        var _info = null;
        if (_controlType == 'select' || _controlType == 'radio') {
          _info = getSelectedItemById(_fieldInfo.values, _val);
          return !_info ? _val : _info.name;
        } else {
          return _val;
        }
      }

    }, config.getTableRowCount, _formFieldsManager.getFormulaFieldIdByName, _formFieldsManager.getFormulaFieldNameById);
  };
  var clearWindow = function () {
    // $txt_formula.val("");
    // $txt_name.val("");
    // $fields.children().add($otherFields.children()).removeClass("disabled using");
    // $calcoperators.removeClass("disabled");
  };
  var showError = function (_error) {
  };
  var validateName = function (_name, _formula) {
    // if (Entos.WFI.config.error.fieldName.validate(_name)) {
    //     $errortip.removeClass("error");
    //     var v = config.validate({
    //         id: $hid_formula_id.val(),
    //         name: _name,
    //         table: _formula.table
    //     });
    //     if (v.retCode == 1) {
    //         return true;
    //     }
    // }
    // $errortip.addClass("error");
    // return false;
    return true;
  };
  var _validate = function (_expr) {
    if (!_expr) {
      if (!config.emptyExpr) {
        return {
          error: {
            index: 0,
            info: "公式格式不能为空！"
          }
        };
      } else {
        return {};
      }

    }
    var result = _parse(_expr);
    if (result.err) {
      return {
        error: {
          index: result.pos,
          info: result.err
        }
      };
    } else {
      return {
        formula: result.sexpr,
        table: result.table,
        depend: result.depend,
        vtype: result.vtype == "num" ? "number" : "date"
      };
    }
  };
  var _translate = function (_expr) {
    return translate(_expr || "", _formFieldsManager.getFormulaFieldInfo, _formFieldsManager.getFormulaFieldNameById);
  };
  var _parse = function (_expr) {
    return parse(_expr || "", _formFieldsManager.getFormulaFieldInfo, _formFieldsManager.getFormulaFieldIdByName);
  };

  var _hideDependFields = function (cformulaId) {
    var _dependFields = _calculator.findWhoDepend(cformulaId);
  };
  var _hideSelfField = function (cformulaId) {
    var _fieldInfo = _formFieldsManager.getFieldInfo(cformulaId);
    if (!_fieldInfo) { return; }
  };
  var _initManegerWindow = function () {
    _window = new Entos.WFI.UI.AutoSizeDialog({
      html: manegerWindowTpl,
      width: 600,
      title: config.title,
      showTitle: true,
      modal: true,
      zIndex: 99999,
      afterHide: function () {
        $formulaerror.hide();
      },
      afterRemove: function () {
        $formulaerror.remove();
      },
      buttons: [
        {
          name: "确定", clz: "save", events: {
            click: function () {
              var _result = _validate($txt_formula.val());
              if (!_result.error && !config.emptyExpr) {
                if (formulaOps) {
                  if (formulaOps.table && formulaOps.table != _result.table)
                    _result.error = { index: 0, info: "该公式计算结果属于“" + (_result.table == "main" ? "主表" : fieldslist[_result.table].name) + "”，而应该属于表“" + (formulaOps.table == "main" ? "主表" : fieldslist[formulaOps.table].name) + "”" };
                  else if (formulaOps.resultType && formulaOps.resultType != _result.vtype)
                    _result.error = { index: 0, info: "该公式计算结果是" + (_result.vtype == "number" ? "数值" : "日期") + "，而应该是" + (formulaOps.resultType == "number" ? "数值" : "日期") };
                }
              }
              if (!_result.error) {
                var _fName = $txt_name.val().replace(/ /g, "");
                if ($txt_formula.val().length == 0 && config.emptyExpr) {
                  _result = Object.assign(_result, {
                    formula: '',
                    table: formulaOps.table,
                    depend: '',
                    vtype: formulaOps.resultType
                  });
                }
                if (!validateName(_fName, _result)) return false;
                config.afterChange({
                  id: $hid_formula_id.val(),
                  name: _fName,
                  formula: $txt_formula.val(),
                  expr: _result.formula,
                  controlType: "autocalc",
                  table: _result.table,
                  depend: _result.depend
                });
              } else {
                showError(_result.error);
              }
              return false;
            }
          }
        },
        {
          name: "取消", clz: "cancel", events: {
            click: function () {
              _hide();
            }
          }
        }
      ]
    });
  };

  var checkIsCondition = function (sexpr) {
    var ntree = parseFormulaStaStructure(sexpr);
    if (!ntree) return false;
    var root = Array.isArray(ntree) ? ntree[0] : ntree;
    var isLogicOperator = ['>', '>=', '<', '<=', '=', '!=', '&', '|'].indexOf(root.type) > -1;
    var isLogicFunc = root.type == 'ident' && ['AND', 'OR', 'NOT', 'ANY'].indexOf(root.val) > -1;
    return isLogicOperator || isLogicFunc;
  };

  var addCondition = function (_cond) {

  };

  var initArea = function () {
    var _id = (new Date()).valueOf(), wid = 'w_' + _id;
    formulaOps = null;
    _initManegerWindow();
    _initFieldItemsTabPanel();
  };
  var bindData = function (_formula) {
    cformula = _formula;
    if (cformula) {
      cformula.formula = cformula.formula || _translate(cformula.expr);
      var _result = _validate(cformula.formula);
      if (cformula.formula && _result.error) {
        showError(_result.error);
      }
    } else {
    }

  };
  var _show = function (_formula, _formulaOps) {
    initArea();
    formulaOps = Object.assign({}, { nameEdit: true, table: null, hasSelf: false, resultType: null, exprs: [] }, _formulaOps);
    bindData(_formula);
    _calculator.clear();
    if (formulaOps)
      for (var e in formulaOps.exprs) {
        if (formulaOps.exprs[e] || formulaOps.exprs[e].length > 0) {
          try {
            _calculator.addExpr(e, formulaOps.exprs[e]);
          } catch (ex) { }
        }

      }
    if (!cformula) return;
    _hideDependFields(cformula.id);
    _hideSelfField(cformula.id);
  };
  var _model = {
    bindFields: function (_tableInfo) {
      tableInfo = _tableInfo;
      fieldslist = _tableInfo.options.fields;
      conditions = _tableInfo.options.conditions || {};
    },
    validate: _validate,
    parse: _parse,
    translate: _translate,
    addExpr: function (_key, _expr) {
      _calculator.addExpr(_key, _expr);
    },
    calc: function () {
      _calculator.calc(config.onCalcChange);
    },
    recalc: function (_key, _rowIndex) {
      _calculator.recalc(_key, _rowIndex, config.onCalcChange);
    }
  };
  init();
  return _model;
};

module.exports = MathFormulaManager;
