const { CONTROLS, SPECIAL_FIELD_CONFIG } = require('../form2/form_field');
const { StringFormula } = require('./lib/formula_string');

var StringFormulaManager = function (cfg) {
  var config = Object.assign({
      container: null,
      title: "事务标题格式设置",
      onChange: function () { },
      showMode: "edit",
      showDemo: true,
      onSave: function () { },
      emptyExpr: false,
      onCalcChange: null
  }, cfg),
  tableInfo, fieldsInfo, selFields, domItems, refTableFields = {}, _formStringFormula, _formFieldsManager;

  var currentOps = { table: "main" }, refTableFieldItems = {}, editorConfig = Entos.WFI.config, initcon = false;

  var expr = _formStringFormula.translate($hiddenItems.val());
  if (currentOps.table != expr.table) {
      Entos.Dialog.topCenterTip({
          isNote: false,
          context: "字段属于表：“" + fieldsInfo[currentOps.table].name + "”，但公式里面没有包含该表的任何内容。"
      });
      return false;
  }
  var bindFormulaFields = function () {

      if (tableInfo) {
          var f;
          for (f in fieldsInfo) {
              var cf = fieldsInfo[f];
              if (!CONTROLS[cf.controlType].isChildTable)
                  addTitleFields(cf, "main");
              else {
                  for (var _f in cf.fields) {
                      var childf = cf.fields[_f];
                      addTitleFields(childf, f);
                  }
              }
          }
      }

  };

  var initContainer = function () {
      bindFormulaFields();
  };

  var init = function () {
      _formFieldsManager = config.fieldsManager;

      _formStringFormula = new StringFormula({
          getFieldInfo: _formFieldsManager.getFormulaFieldInfo,
          getFieldInfoByName: _formFieldsManager.getFormulaFieldInfoByName,
          getFieldData: config.getFieldData,
          getTableRowCount: config.getTableRowCount
      });
  };

  var record = function () {
      var _str = _formStringFormula.parse($txtItems.val());
  };

  var refreshRecord = function () {
      var _str = _formStringFormula.translate($hiddenItems.val());
      $txtItems.val(_str.str);
      $extendinfo.html(Entos.WFI.common.transHtml(_str.html));
  };

  var setInputValue = function (_value) {
      record();
  };

  var addTitleFields = function (_fieldInfo, _tableId) {
      _fieldInfo.table = _tableId;
      var fieldConfig = SPECIAL_FIELD_CONFIG[_fieldInfo.id];
      if (CONTROLS[_fieldInfo.controlType].isChildTable || _fieldInfo.controlType == "textarea"
          || (fieldConfig && !fieldConfig.inFormulaEdit) || _fieldInfo.controlType == "autocalc" || _fieldInfo.controlType == "autogrow") return;

      var _preName = _tableId == "main" ? _fieldInfo.name : (fieldsInfo[_tableId].name + "." + _fieldInfo.name);
      config.showMode != "read" && $field.click(function () {
          setInputValue("{" + _preName + "}");
      });

      if (selFields && selFields.indexOf("," + _fieldInfo.id + ",") > -1) {
          addTitleField(_fieldInfo);
      }

      refTableFieldItems[_fieldInfo.id] = refTableFieldItems[_fieldInfo.id] || [];
      refTableFieldItems[_fieldInfo.id].push($field);

      if (_fieldInfo.controlType != "select" && _fieldInfo.controlType != "orgunit" && _fieldInfo.controlType != "user" || !_fieldInfo.valueSource || !tableInfo.dictionaryTables) return;

      var tempVisitedDT = {};
      var addRefField = function (_refField, _name, _id, $table) {
          if (_refField.enable != 1) return;
          _name = _name + "." + _refField.name;
          _id = _id + "." + _refField.id;
          if (_refField.controlType == "select" && _refField.valueSource) {

              addDT(_refField.valueSource, _name, _id);
              return false;
          }

          refTableFields.fields[_id] = {
              id: _id,
              name: _name,
              controlType: _refField.controlType == "textbox" ? "textbox" : "number",
              table: _tableId
          };
          refTableFields.names[_name] = refTableFields.fields[_id];

          if (config.showMode == "read") return true;
          return true;
      };

      var addDT = function (_dtId, _name, _id) {
          if (tempVisitedDT[_dtId]) return;
          tempVisitedDT[_dtId] = 1;
          refTableFieldItems[_fieldInfo.id] = refTableFieldItems[_fieldInfo.id] || [];
          for (var i = 0, j = tableInfo.dictionaryTables.length; i < j; i++) {
              var ci = tableInfo.dictionaryTables[i], isAdd = false;
              if (ci.id == _dtId) {
                  ci.options = typeof ci.options == "string" ? JSON.parse(ci.options) : ci.options;
                  for (var refId in ci.options.fields) {
                      if (refId == "f1" && _id == _fieldInfo.id || refId == "fenable") continue;
                      var refField = ci.options.fields[refId];
                      isAdd = addRefField(refField, _name, _id + ".s" + ci.id) ? true : isAdd;
                  }
                  break;
              }
          }

      };

      addDT(_fieldInfo.valueSource, _preName, _fieldInfo.id);
  };

  var bindFields = function (_tableInfo) {
      tableInfo = _tableInfo;
      fieldsInfo = tableInfo.options.fields;
      refTableFields = { fields: {}, names: {} };
      bindFormulaFields();
  };

  var _data = function () {
      if (!initcon) return {
          expr: "",
          str: ""
      };
      return {
          id: currentOps && currentOps.field ? currentOps.field.id : null,
          expr: $hiddenItems.val(),
          str: $txtItems.val()
      };
  };

  //更新当前选中filed标签
  var updateCurrentFieldTagsData = function (curItemString) {
      var re = /(\{.*?\})/g, arr, ret = curItemString;
      while ((arr = re.exec(curItemString)) != null) {
          var key = arr[0].replace(/^\{/g, '').replace(/\}$/g, '');
          if (!fieldsInfo[key]) {
              ret = ret.replace(arr[0], '');
          }
      }
      return ret;
  };

  var _show = function (_currentOps) {
      if (!initcon) initContainer();
      currentOps = $.extend(true, {
          table: "main",
          titles: selFields,
          field: null,
          exprs: {}
      }, _currentOps);
      selFields = currentOps.titles;
      _formStringFormula.clear();

      for (var e in currentOps.exprs)
          _formStringFormula.addExpr(e, currentOps.exprs[e]);

      if (!fieldsInfo) return;
      if ($parentCon) {
          $con.show();
      } else {
          _window.show();
      }
      $mainfieldsul.children("[_table]").show();
      if (currentOps.table == "main") {
          $mainfieldsul.children("[_table!='main']").hide();
      } else {
          $mainfieldsul.children("[_table!='main'][_table!='" + currentOps.table + "']").hide();
          $mainfieldsul.children("[_table='" + currentOps.table + "']").show();
      }

      if (currentOps.field) {
          var _dependFields = _formStringFormula.findWhoDepend(currentOps.table == "main" ? currentOps.field.id : (currentOps.table + "." + currentOps.field.id));
          $(_dependFields).each(function (i, e) {
              $mainfieldsul.find("a:has(span[_field='" + (e.indexOf(".") > -1 ? e.split(".")[1] : e) + "'])").hide();
          });
      }


      if (currentOps.field && refTableFieldItems[currentOps.field.id]) {
          for (var i = 0; i < refTableFieldItems[currentOps.field.id].length; i++)
              refTableFieldItems[currentOps.field.id][i].hide();
      }

      //更新当前选中filed标签
      if (!selFields) {
          $hiddenItems.val(selFields);
          //$hiddenItems.val(updateCurrentFieldTagsData($hiddenItems.val()));
      } else {
          $hiddenItems.val(selFields);
      }
      refreshRecord();
      config.onChange && config.onChange();
  };

  var _translate = function (_titles, _titleData, _op) {
      _op = $.extend(true, {
          noHtml: false
      }, _op);
      var noHtml = _op.noHtml;
      if (!tableInfo || !_titles) return "";
      if (!_titleData) return _formStringFormula.translate(_titles).str;
      var _matchArray = _titles.match(/\{[^\{\}]{2,}?\}/g),
          len = _matchArray ? _matchArray.length : 0,
          cmatch, cfield, _id;

      for (var index = 0; index < len; index++) {
          cmatch = _matchArray[index];
          _id = cmatch.replace(/\{|\}/g, "");
          cfield = fieldsInfo[_id];
          if (cfield) {
              _titles = _titles.replace(new RegExp(cmatch, "g"), _formFieldsManager.getValueByControlType(cfield, _titleData.titles[cfield.id], noHtml));
          } else {
              cfield = refTableFields.fields[_id];
              if (!cfield) continue;
              var _ids = _id.split("."), _v = _titleData.titles[_ids[0]];
              _ids.splice(0, 1);
              _v = _formFieldsManager.getRefTableFieldValue(_ids, _v);
              _titles = _titles.replace(new RegExp(cmatch, "g"), _v);
          }
      }
      return _titles;
  };


  var _model = {
      data: _data,
      bindFields: bindFields,
      translate: _translate,
      addExpr: function (_key, _expr) {
          _formStringFormula.addExpr(_key, _expr);
      },
      calc: function () {
          _formStringFormula.calcExprs(config.onCalcChange, config.getFieldData, config.getTableRowCount);
      }
  };

  init();
  return _model;
};