const { COMPONENT_TYPE } = require('../../lib/component/component_type');

const PROJECT = {
  unique_no: 'sprojects',
  tableName: 'projects',
  level: 1,
  config: {
    fields: [
      {
        uuid: 'fid',
        name: 'id',
      },
      {
        uuid: 'fproject_id',
        name: '父级项目',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fseq_no',
        name: '项目编号',
        controlType: COMPONENT_TYPE.TEXT,
      },
      {
        uuid: 'fprojects',
        name: '子项目',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_stages',
        ref: 'sproject_stages',
        name: '项目阶段',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_members',
        ref: 'sproject_members',
        name: '项目成员',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_roles',
        ref: 'sproject_roles',
        name: '项目角色',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
    ],
  }
};
const PROJECT_STAGE = {
  unique_no: 'sproject_stages',
  visible: false,
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fproject_id',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fname'
      },
      {
        uuid: 'fproject_tasks',
        ref: 'sproject_tasks',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
    ],
  }
};
const PROJECT_TASK = {
  unique_no: 'sproject_tasks',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fproject_stages',
        ref: 'sproject_stages',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fname'
      },
      {
        uuid: 'fstandard_time',
        name: '任务名称'
      },
      {
        uuid: 'fworking_times',
        ref: 'sworking_times',
        name: '任务工时表',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_task_users',
        ref: 'sproject_task_users',
        name: '任务负责人表',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
    ],
  }
};
const PROJECT_TASK_USER = {
  unique_no: 'sproject_task_users',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fproject_tasks',
        ref: 'sproject_tasks',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fproject_members',
        ref: 'sproject_members',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
    ],
  }
};
const PROJECT_MEMBER = {
  unique_no: 'sproject_members',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fproject_id',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fuser_id',
        ref: 'susers',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fproject_task_users',
        ref: 'sproject_task_users',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
      {
        uuid: 'fproject_member_roles',
        ref: 'sproject_member_roles',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const PROJECT_ROLE = {
  unique_no: 'sproject_roles',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fprojects',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fname',
      },
      {
        uuid: 'fproject_member_roles',
        ref: 'sproject_member_roles',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const PROJECT_MEMBER_ROLE = {
  unique_no: 'sproject_member_roles',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fproject_members',
        ref: 'sproject_members',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fproject_roles',
        ref: 'sproject_roles',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
    ],
  }
};
const DEPARTMENT = {
  unique_no: 'sdepartments',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fname'
      },
      {
        uuid: 'fdepartment_user_relationships',
        ref: 'sdepartment_user_relationships',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const USER = {
  unique_no: 'susers',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fname',
        name: '员工姓名',
      },
      {
        uuid: 'fproject_members',
        ref: 'sproject_members',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
      {
        uuid: 'fdepartment_user_relationships',
        ref: 'sdepartment_user_relationships',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
      {
        uuid: 'fworking_times',
        ref: 'sworking_times',
        name: '员工工时',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const DEPARTMENT_USER = {
  unique_no: 'sdepartment_user_relationships',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fdepartments',
        ref: 'sdepartments',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fusers',
        ref: 'susers',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
    ],
  }
};

const WORKING_TIME = {
  unique_no: 'sworking_times',
  config: {
    fields: [
      {
        uuid: 'fid',
      },
      {
        uuid: 'fusers',
        ref: 'susers',
        name: '员工',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fproject_tasks',
        ref: 'sproject_tasks',
        name: '任务',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fdate',
        name: '时间',
      },
      {
        uuid: 'fplan_time',
        name: '计划工时',
      },
      {
        uuid: 'factual_time',
        name: '实际工时',
      },
    ],
  },
};


const GLOBAL_TABLE = {
  PROJECT,
  PROJECT_STAGE,
  PROJECT_TASK,
  PROJECT_TASK_USER,
  PROJECT_MEMBER,
  PROJECT_ROLE,
  PROJECT_MEMBER_ROLE,
  DEPARTMENT,
  USER,
  DEPARTMENT_USER,
  WORKING_TIME,
};

module.exports = GLOBAL_TABLE;