const { COMPONENT_TYPE } = require('../../lib/component/component_type');

const PROJECT = {
  unique_no: 'sprojects',
  config: {
    fields: [
      {
        uuid: 'fid',
        name: 'id',
      },
      {
        uuid: 'fproject_id',
        name: '父级项目',
        dataType: 'sprojects',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fseq_no',
        name: '项目编号',
      },
      {
        uuid: 'fprojects',
        name: '子项目',
        dataType: 'sprojects',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_stages',
        dataType: 'sproject_stages',
        name: '项目阶段',
        ref: 'sproject_stages',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_members',
        dataType: 'sproject_members',
        name: '项目成员',
        ref: 'sproject_members',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fproject_roles',
        dataType: 'sproject_roles',
        name: '项目角色',
        ref: 'sproject_roles',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
    ],
  }
};

const PROJECT_MEMBER = {
  unique_no: 'sproject_members',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fprojects',
        dataType: 'sprojects',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fusers',
        dataType: 'susers',
        ref: 'susers',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fproject_member_roles',
        dataType: 'sproject_role',
        ref: 'sproject_member_roles',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const PROJECT_STAGE = {
  unique_no: 'sproject_stages',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fprojects',
        ref: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fname'
      },
      {
        uuid: 'fproject_tasks',
        ref: 'sproject_tasks',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
    ],
  }
};
const PROJECT_TASK = {
  unique_no: 'sproject_tasks',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fproject_stages',
        ref: 'sproject_stages',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fname'
      },
      {
        uuid: 'fstandard_time',
        name: '任务名称'
      },
      {
        uuid: 'fworking_times',
        ref: 'sworking_times',
        name: '任务工时表',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
      {
        uuid: 'fowners',
        ref: 'susers',
        name: '任务负责人表',
        controlType: COMPONENT_TYPE.CHILD_TABLE
      },
    ],
  }
};

const PROJECT_ROLE = {
  unique_no: 'sproject_roles',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fprojects',
        dataType: 'sprojects',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fname',
      },
      {
        uuid: 'fmembers',
        dataType: 'susers',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const DEPARTMENT = {
  unique_no: 'sdepartments',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fname'
      },
      {
        uuid: 'fdepartment_user_relationships',
        dataType: 'susers',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};
const USER = {
  unique_no: 'susers',
  config: {
    fields: [
      {
        uuid: 'fid'
      },
      {
        uuid: 'fname',
        name: '员工姓名',
      },
      {
        uuid: 'fprojects',
        dataType: 'sprojects',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
      {
        uuid: 'fdepartments',
        dataType: 'sdepartments',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
      {
        uuid: 'fworking_times',
        dataType: 'sworking_times',
        name: '员工工时',
        controlType: COMPONENT_TYPE.CHILD_TABLE,
      },
    ],
  }
};

const WORKING_TIME = {
  unique_no: 'sworking_times',
  config: {
    fields: [
      {
        uuid: 'fid',
      },
      {
        uuid: 'fusers',
        dataType: 'susers',
        name: '员工',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fproject_tasks',
        dataType: 'sproject_tasks',
        name: '任务',
        controlType: COMPONENT_TYPE.FOREIGN_REF,
      },
      {
        uuid: 'fdate',
        name: '时间',
      },
      {
        uuid: 'fplan_time',
        name: '计划工时',
      },
      {
        uuid: 'factual_time',
        name: '实际工时',
      },
    ],
  },
};


const GLOBAL_TABLE = {
  PROJECT,
  PROJECT_STAGE,
  PROJECT_TASK,
  PROJECT_TASK_USER,
  PROJECT_MEMBER,
  PROJECT_ROLE,
  PROJECT_MEMBER_ROLE,
  DEPARTMENT,
  USER,
  DEPARTMENT_USER,
  WORKING_TIME,
};

module.exports = GLOBAL_TABLE;