const COMPONENT_TYPE = {
  TEXT: "text",
  TEXTAREA: "textarea",
  NUMBER: "number",
  RADIO: "radio",
  CHECKBOX: "checkbox",
  SELECT: "select",
  SELECTCOLOR: "select_color",
  MULTIPLE_SELECT: "multiple_select",
  FOREIGN_REF: "foreign_ref",
  CHILD_TABLE: "child_table",
  DATE: "date",
  DATE_RANGE: "date_range",
  TELEPHONE: "telephone",
  EMAIL: "email",
  HR: "hr",
  FILE: "file",
  OWNER: "owner",
  ROLE: "ROLE",
  DEPARTMENT: "DEPARTMENT",
  USER: "USER",
  TASK: "task",
  STRING_FORMULA: "string_formula",
  MATH_FORMULA: "autocalc",
  MEMBER: "member",
  AUTO_NUMBER: "autonumber",
  DEFAULTVALUE: "defaultvalue",
}
const FormItemType = {
  SELECT: 0, // 下拉
  SELECTCOLOR: 1, // 下拉带颜色
  INPUT: 2, // 输入框
  INPUTNUMBER: 3, // 数字输入框
  DATE: 4, // 单日期
  TEXTAREA: 6, // 多行文本
  SELECTMULTIP: 11,
  RadioGroup: 12,
  CheckBoxGroup: 13,
  Dividingline: 14,
  RangePicker: 15,
  FILE: 16,
  FOREIGNREF: 17,
  TASK: 18,
  OWNER: 22,
  AUTONUMBER: 23,
  MEMBER: 24,
  MATH_FORMULA: 25,
  DEFAULTVALUE: 26,
}
const COMPONENT_RENDER_TYPE = {
  [COMPONENT_TYPE.TEXT]: FormItemType.INPUT,
  [COMPONENT_TYPE.TEXTAREA]: FormItemType.TEXTAREA,
  [COMPONENT_TYPE.HR]: FormItemType.Dividingline,
  [COMPONENT_TYPE.EMAIL]: FormItemType.INPUT,
  [COMPONENT_TYPE.TELEPHONE]: FormItemType.INPUT,
  [COMPONENT_TYPE.SELECT]: FormItemType.SELECT,
  [COMPONENT_TYPE.SELECTCOLOR]: FormItemType.SELECTCOLOR,
  [COMPONENT_TYPE.MULTIPLE_SELECT]: FormItemType.SELECTMULTIP,
  [COMPONENT_TYPE.RADIO]: FormItemType.RadioGroup,
  [COMPONENT_TYPE.CHECKBOX]: FormItemType.CheckBoxGroup,
  [COMPONENT_TYPE.NUMBER]: FormItemType.INPUTNUMBER,
  [COMPONENT_TYPE.DATE]: FormItemType.DATE,
  [COMPONENT_TYPE.DATE_RANGE]: FormItemType.RangePicker,
  [COMPONENT_TYPE.OWNER]: FormItemType.SELECT,
  [COMPONENT_TYPE.FILE]: FormItemType.FILE,
  [COMPONENT_TYPE.TASK]: FormItemType.TASK,
  [COMPONENT_TYPE.FOREIGN_REF]: FormItemType.FOREIGNREF,
  [COMPONENT_TYPE.AUTO_NUMBER]: FormItemType.AUTONUMBER,
  [COMPONENT_TYPE.MEMBER]: FormItemType.OWNER,
  [COMPONENT_TYPE.MATH_FORMULA]: FormItemType.MATH_FORMULA,
  [COMPONENT_TYPE.DEFAULTVALUE]: FormItemType.SELECT,
}

const DATASOURCE = {
  API: "API",
  API_METHOD: "API_METHOD",
}

module.exports = { COMPONENT_TYPE, COMPONENT_RENDER_TYPE, DATASOURCE }
