/~ ---exprparser.js is builded by formula_parser.js.y ---~/
[*
(function(){
var Expr_parsedResult = null;
*]

/~ --- Token definitions --- ~/

/~ Characters to be ignored ~/
! ' |\t|\r|\n' ;

/~ lowest precedence ~/

< "\|" [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  ;
< "&"  [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  ;
^ '='  [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '!=' [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '>=' [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '>'  [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '<=' [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '<'  [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  ;

< '\+' [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '\-' [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  ;
        
< '\*' [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '/'  [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  ;

/~ highest precedence ~/

/~ Non-associative tokens ~/
  '\('                               [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '\)'                               [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  ','                                [* var x=%match.length; %match = {type:%match, pos:%offset, length:x, len:x}; *]
  '[0-9]+(\.[0-9]+)?'         NUM    [* var x=%match.length; %match = {type:'num', pos:%offset, val:%match, length:x, len:x}; *]
  '\"[^\"]*\"'                STRING [* var x=%match.length; %match = {type:'string', pos:%offset, val:%match, length:x, len:x}; *]
  '\'[^\']*\''                STRING [* var x=%match.length; %match = {type:'string', pos:%offset, val:%match, length:x, len:x}; *]
  '[A-Za-z_\256-\65535][\.0-9A-Za-z_\256-\65535]*' IDENT [* var x=%match.length; %match = {type:'ident', pos:%offset, val:%match, length:x, len:x}; *]
  '.'                         BAD    [* var x=%match.length; %match = {type:"bad", pos:%offset, val:%match, length:x, len:x}; *]
  ;

##

/~ --- Grammar specification --- ~/

p: e              [* Expr_parsedResult = %1; *]
        ;

e: e '+' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '-' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '=' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '!=' e             [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '>=' e             [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '>' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '<=' e             [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '&' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '|' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '<' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '*' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | e '/' e              [* %% = [%2, %1, %3]; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | '-' e &'*'           [* %% = [%1, %2]; var x=%1.pos; %%.pos=x; %%.len=(%2.pos - x) + %2.len; *]
 | '(' e ')'            [* %% = %2; var x=%1.pos; %%.pos=x; %%.len=(%3.pos - x) + %3.len; *]
 | NUM
 | STRING
 | IDENT
 | IDENT '(' params ')' [* %% = [%1].concat(%3); var x=%1.pos; %%.pos=x; %%.len=(%4.pos - x) + %4.len; *]
 ;

params: e              [* %% = [%1]; *]
 | params ',' e        [* %% = %1.concat(%3); *]
 ;

[*
IX.ns("window.Entos.Formula");
IX.extend(window.Entos.Formula, {
  lex: __Exprlex,
  _parse: function(expr, erroffsets, errlookaheads) {
    var nerr = __Exprparse(expr, erroffsets, errlookaheads);
    return {nerr:nerr, result: Expr_parsedResult};
  },
  EOF_symbol: Expr_EOF_symbol
});
})();
*]
