const { COMPONENT_TYPE } = require('../../src/lib/base/component_type');
const PROJECT = {
  fields: [
    {
      id: 'fid',
      name: '项目id',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fseq_no',
      name: '项目编号',
      controlType: COMPONENT_TYPE.TEXT,
    },
    {
      id: 'fmanager',
      name: '项目负责人',
      controlType: COMPONENT_TYPE.OWNER,
    },
    {
      id: 'fmember',
      name: '项目成员',
      controlType: COMPONENT_TYPE.CHILD_TABLE,
      ref: 'sprojectmember',
    },
    {
      id: 'frole',
      name: '项目角色',
      controlType: COMPONENT_TYPE.CHILD_TABLE,
      ref: 'sprojectrole',
    },
    {
      id: 'fstage',
      name: '任务清单',
      controlType: COMPONENT_TYPE.CHILD_TABLE,
      ref: 'sprojectstage',
    },
    {
      id: 'fmilestone',
      name: '里程碑',
      controlType: COMPONENT_TYPE.CHILD_TABLE,
      ref: 'sprojectmilestone',
    }
  ],
};

const USER = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fname',
      name: '用户名称',
      controlType: COMPONENT_TYPE.TEXT,
    }
  ]
};

const PROJECT_ROLE = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fname',
      name: '角色名称',
      controlType: COMPONENT_TYPE.TEXT,
    },
    {
      id: 'ftype',
      name: '角色类型',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fproject',
      name: '项目id',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sproject'
    }
  ]
};

const PROJECT_MEMBER = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fproject',
      name: '项目id',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sproject'
    },
    {
      id: 'fmember',
      name: '用户',
      controlType: COMPONENT_TYPE.OWNER,
    },
  ]
};

const PROJECT_MEMBER_ROLE = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fprojectmember',
      name: '项目成员',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sprojectmember'
    },
    {
      id: 'frole',
      name: '用户角色',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sprojectrole'
    }
  ]
};

const PROJECT_STAGE = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fname',
      controlType: COMPONENT_TYPE.TEXT,
    },
    {
      id: 'fproject',
      name: '项目id',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sproject'
    },
    {
      id: 'fprojecttask',
      name: '任务',
      controlType: COMPONENT_TYPE.CHILD_TABLE,
      ref: 'sprjecttask'
    },
  ],
};

const PROJECT_TASK = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fname',
      controlType: COMPONENT_TYPE.TEXT,
    },
    {
      id: 'fprojectstage',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'fprojectstage'
    },
    {
      if: 'fowner',
      controlType: COMPONENT_TYPE.CHILD_TABLE,
      ref: 'sprojecttaskowner'
    }
  ],
};

const PROJECT_TASK_OWNER = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fowner',
      controlType: COMPONENT_TYPE.OWNER,
    },
    {
      id: 'fprojecttask',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sprojecttask'
    }
  ],
};

const WORKING_TIME = {
  fields: [
    {
      id: 'fid',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'fowner',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'suser',
    },
    {
      id: 'ftask',
      controlType: COMPONENT_TYPE.FOREIGN_REF,
      ref: 'sprojecttask',
    },
    {
      id: 'fplantime',
      controlType: COMPONENT_TYPE.NUMBER,
    },
    {
      id: 'factualtime',
      controlType: COMPONENT_TYPE.NUMBER,
    }
  ],
};

// const MILESTONE = {
//   fields: [
//     {
//       id: 'fid',
//       controlType: COMPONENT_TYPE.NUMBER,
//     },
//     {
//       id: 'fname',
//       controlType: COMPONENT_TYPE.TEXT,
//     },
//     {
//       id: 'fproject',
//       controlType: COMPONENT_TYPE.PROJECT,
//     }
//   ],
// };