const { FormManager } = require("../../src/lib/form/form_manager")

const formManager = new FormManager({
  onFieldValueChanged(rowIndex, fid, value) {
    console.info(rowIndex, fid, value)
  },
  getCurrentDate() {
    return new Date()
  },
  async getNumber(fid) {
    // redis
  },
})

formManager.bindForm({
  id: 7816,
  company_id: 1,
  name: "全部组件",
  setting: {
    sort: [
      "f2",
      "f3",
      "f4",
      "f5",
      "f6",
      "f7",
      "f8",
      "f9",
      "f10",
      "f11",
      "f12",
      "f13",
      "f14",
      "f15",
      "f16",
      "f17",
      "f18",
      "f19",
      "f20",
      "f21",
      "f22",
      "f23",
      "f24",
      "f25",
      "f26",
      "f27",
    ],
    fields: [
      {
        id: "f2",
        desc: "",
        label: "单行文本1",
        required: false,
        controlType: "text",
        placeholder: "",
      },
      {
        id: "f3",
        desc: "",
        label: "多行文本1",
        required: false,
        controlType: "textarea",
        placeholder: "",
      },
      {
        id: "f4",
        desc: "",
        label: "下拉单选1",
        value: null,
        options: [
          {
            color: "",
            label: "选择项",
            value: "1",
          },
          {
            color: "",
            label: "选择项",
            value: "2",
          },
          {
            color: "",
            label: "选择项",
            value: "3",
          },
        ],
        required: false,
        controlType: "select_color",
        placeholder: "",
      },
      {
        id: "f5",
        desc: "默认选中选项2",
        label: "下拉复选1",
        value: ["2"],
        options: [
          {
            color: "",
            label: "选择项1",
            value: "1",
          },
          {
            color: "",
            label: "选择项2",
            value: "2",
          },
          {
            color: "",
            label: "选择项3",
            value: "3",
          },
          {
            color: "",
            label: "选择项4",
            value: "4",
          },
          {
            color: "",
            label: "选择项5",
            value: "5",
          },
          {
            color: "",
            label: "选择项6",
            value: "6",
          },
        ],
        required: false,
        controlType: "multiple_select",
        placeholder: "",
      },
      {
        id: "f6",
        unit: "个",
        label: "数字1",
        digits: 4,
        required: false,
        controlType: "number",
        placeholder: "4个小数点",
      },
      {
        id: "f7",
        desc: "行的创建--日",
        label: "单日期1",
        required: false,
        dateFormat: "DD",
        controlType: "date",
        dateDefaultValue: "create",
      },
      {
        id: "f8",
        desc: "",
        label: "邮箱1",
        required: false,
        controlType: "email",
        placeholder: "",
      },
      {
        id: "f9",
        desc: "",
        label: "电话1",
        required: false,
        controlType: "telephone",
        placeholder: "手机号码",
        telephoneType: 1,
      },
      {
        id: "f10",
        max: 100,
        desc: "",
        label: "文件1",
        required: false,
        controlType: "file",
      },
      {
        id: "f11f2f1fseqno",
        max: 100,
        min: 0,
        desc: "",
        label: "项目编号",
        join_form: "s1007815.f2f1fseqno",
        controlType: "text",
        joined_form: [],
        placeholder: "",
      },
      {
        id: "f11f2f1fchildno",
        max: 100,
        min: 0,
        desc: "",
        label: "中心编号",
        join_form: "s1007815.f2f1fchildno",
        controlType: "text",
        joined_form: [],
        placeholder: "",
      },
      {
        id: "f11f2f1fchildname",
        max: 100,
        min: 0,
        desc: "",
        label: "中心名称",
        join_form: "s1007815.f2f1fchildname",
        controlType: "text",
        joined_form: [],
        placeholder: "",
      },
      {
        id: "f11f2f1fstatus",
        desc: "",
        label: "中心状态",
        options: [
          {
            color: "",
            label: "待开始",
            value: "1",
          },
          {
            color: "",
            label: "进行中",
            value: "2",
          },
          {
            color: "",
            label: "已完成",
            value: "3",
          },
        ],
        join_form: "s1007815.f2f1fstatus",
        controlType: "select_color",
        joined_form: [],
        placeholder: "",
      },
      {
        id: "f12",
        desc: "1",
        expr: 818,
        label: "用户1",
        range: "role",
        choice: "multiple",
        value_key: [
          {
            id: 44,
            name: "PM",
            count: 0,
            role_type: 2,
            unique_no: "900000_0",
          },
        ],
        value_type: "current_user",
        controlType: "member",
        value_range: "project",
      },
      {
        id: "f13",
        desc: "引用字段是引用了关联他表（第三次关联）的项目编号",
        label: "自动编号1",
        rules: [
          {
            type: "autono",
            title: "自动编号",
            value: {
              digit: 3,
              start: "997",
              numbering: "digit",
              cycle_type: "day",
              auto_increment: true,
              increment_rule: "f7",
            },
          },
          {
            type: "fixed_value",
            title: "固定字符",
            value: "CCC",
          },
          {
            type: "field",
            title: "引用字段",
            value: {
              expr: "f11f2f1fseqno",
              format: "",
            },
          },
        ],
        version: 1638330513277,
        controlType: "autonumber",
      },
      {
        id: "f14",
        desc: "",
        expr: 'DATE_ADD(f7,1,"month")',
        label: "加一个月的日期",
        controlType: "autocalc",
      },
      {
        id: "f15",
        desc: "",
        label: "单行文本2",
        required: false,
        controlType: "text",
        placeholder: "",
      },
      {
        id: "f16",
        desc: "",
        label: "多行文本2",
        required: false,
        controlType: "textarea",
        placeholder: "",
      },
      {
        id: "f17",
        desc: "",
        label: "下拉单选2",
        value: null,
        options: [
          {
            color: "#FFC3D1",
            label: "选择项11",
            value: "1",
          },
          {
            color: "#FE7B7B",
            label: "选择项22",
            value: "2",
          },
          {
            color: "#FFB700",
            label: "选择项33",
            value: "3",
          },
          {
            color: "#97E37B",
            label: "选择项44",
            value: "4",
          },
          {
            color: "#009A5E",
            label: "选择项55",
            value: "5",
          },
        ],
        required: false,
        controlType: "select_color",
        placeholder: "",
      },
      {
        id: "f18",
        desc: "",
        label: "下拉复选2",
        value: ["1", "2", "3"],
        options: [
          {
            color: "",
            label: "选择项1111",
            value: "1",
          },
          {
            color: "",
            label: "选择项2222",
            value: "2",
          },
          {
            color: "",
            label: "选择项3333",
            value: "3",
          },
          {
            color: "",
            label: "选择项4444",
            value: "4",
          },
          {
            color: "",
            label: "选择项5555",
            value: "5",
          },
          {
            color: "",
            label: "选择项6666",
            value: "6",
          },
        ],
        required: false,
        controlType: "multiple_select",
        placeholder: "",
      },
      {
        id: "f19",
        unit: "个",
        label: "数字2",
        digits: 1,
        required: false,
        controlType: "number",
      },
      {
        id: "f20",
        desc: "创建日期-年月日",
        label: "单日期2",
        required: false,
        dateFormat: "YYYY-MM-DD",
        controlType: "date",
        dateDefaultValue: "create",
      },
      {
        id: "f21",
        desc: "",
        label: "邮箱2",
        required: false,
        controlType: "email",
        placeholder: "",
      },
      {
        id: "f22",
        desc: "",
        label: "电话2",
        required: false,
        controlType: "telephone",
        placeholder: "座机",
        telephoneType: 2,
      },
      {
        id: "f23",
        max: 100,
        desc: "",
        label: "文件2",
        required: false,
        controlType: "file",
      },
      {
        id: "f24fphase",
        desc: "",
        label: "项目分期",
        value: null,
        options: [
          {
            color: "",
            label: "Ⅰ期",
            value: "1",
          },
          {
            color: "",
            label: "Ⅱ期",
            value: "2",
          },
          {
            color: "",
            label: "Ⅲ期",
            value: "3",
          },
          {
            color: "",
            label: "Ⅳ期",
            value: "4",
          },
        ],
        join_form: "s1007668.fphase",
        controlType: "select_color",
        placeholder: "",
      },
      {
        id: "f24fstatus",
        desc: "",
        label: "项目状态",
        value: null,
        options: [
          {
            color: "",
            label: "待开始",
            value: "1",
          },
          {
            color: "",
            label: "进行中",
            value: "2",
          },
          {
            color: "",
            label: "已完成",
            value: "3",
          },
        ],
        join_form: "s1007668.fstatus",
        controlType: "select_color",
        placeholder: "",
      },
      {
        id: "f24fcurrentmilestone",
        max: 100,
        min: 0,
        desc: "",
        label: "当前里程碑",
        value: null,
        join_form: "s1007668.fcurrentmilestone",
        controlType: "text",
        placeholder: "",
      },
      {
        id: "f24findication",
        max: 100,
        min: 0,
        desc: "",
        label: "适应症",
        value: null,
        join_form: "s1007668.findication",
        controlType: "text",
        placeholder: "",
      },
      {
        id: "f25",
        desc: "主项目-一人-当前创建人",
        expr: 818,
        label: "用户2",
        range: "project",
        choice: "single",
        value_key: [],
        value_type: "current_user",
        controlType: "member",
        value_range: "",
      },
      {
        id: "f26",
        label: "自动编号2",
        rules: [
          {
            type: "autono",
            title: "自动编号",
            value: {
              start: 2,
              numbering: "natural",
              cycle_type: "no",
              auto_increment: true,
              increment_rule: "all",
            },
          },
        ],
        version: 1638330513277,
        controlType: "autonumber",
      },
      {
        id: "f27",
        desc: "",
        expr: "",
        label: "公式2",
        controlType: "autocalc",
      },
    ],
    join_table: [
      {
        id: "f11",
        comps: [
          {
            id: "f2f1fseqno",
            max: 100,
            min: 0,
            desc: "",
            label: "项目编号",
            value: null,
            join_form: "s1007814.f1fseqno",
            controlType: "text",
            joined_form: [
              {
                join_form: "s1007816.f11f2f1fseqno",
              },
            ],
            placeholder: "",
          },
          {
            id: "f2f1fchildno",
            max: 100,
            min: 0,
            desc: "",
            label: "中心编号",
            value: null,
            join_form: "s1007814.f1fchildno",
            controlType: "text",
            joined_form: [
              {
                join_form: "s1007816.f11f2f1fchildno",
              },
            ],
            placeholder: "",
          },
          {
            id: "f2f1fchildname",
            max: 100,
            min: 0,
            desc: "",
            label: "中心名称",
            value: null,
            join_form: "s1007814.f1fchildname",
            controlType: "text",
            joined_form: [
              {
                join_form: "s1007816.f11f2f1fchildname",
              },
            ],
            placeholder: "",
          },
          {
            id: "f2f1fstatus",
            desc: "",
            label: "中心状态",
            value: null,
            options: [
              {
                color: "",
                label: "待开始",
                value: "1",
              },
              {
                color: "",
                label: "进行中",
                value: "2",
              },
              {
                color: "",
                label: "已完成",
                value: "3",
              },
            ],
            join_form: "s1007814.f1fstatus",
            controlType: "select_color",
            joined_form: [
              {
                join_form: "s1007816.f11f2f1fstatus",
              },
            ],
            placeholder: "",
          },
        ],
        label: "关联他表",
        fields: ["f2f1fseqno", "f2f1fchildno", "f2f1fchildname", "f2f1fstatus"],
        filters: [],
        form_id: 7815,
        form_type: 1,
        unique_no: "s1007815",
        project_id: 1971,
        controlType: "foreign_ref",
      },
      {
        id: "f24",
        comps: [
          {
            id: "fphase",
            desc: "",
            label: "项目分期",
            value: null,
            options: [
              {
                color: "",
                label: "Ⅰ期",
                value: "1",
              },
              {
                color: "",
                label: "Ⅱ期",
                value: "2",
              },
              {
                color: "",
                label: "Ⅲ期",
                value: "3",
              },
              {
                color: "",
                label: "Ⅳ期",
                value: "4",
              },
            ],
            join_form: "s1007668.fphase",
            controlType: "select_color",
            joined_form: [
              {
                join_form: "s1007683.f2fphase",
              },
              {
                join_form: "s1007811.f1fphase",
              },
              {
                join_form: "s1007813.f1fphase",
              },
            ],
            placeholder: "",
          },
          {
            id: "fstatus",
            desc: "",
            label: "项目状态",
            value: null,
            options: [
              {
                color: "",
                label: "待开始",
                value: "1",
              },
              {
                color: "",
                label: "进行中",
                value: "2",
              },
              {
                color: "",
                label: "已完成",
                value: "3",
              },
            ],
            join_form: "s1007668.fstatus",
            controlType: "select_color",
            joined_form: [
              {
                join_form: "s1007683.f2fstatus",
              },
              {
                join_form: "s1007811.f1fstatus",
              },
              {
                join_form: "s1007813.f1fstatus",
              },
            ],
            placeholder: "",
          },
          {
            id: "fcurrentmilestone",
            max: 100,
            min: 0,
            desc: "",
            label: "当前里程碑",
            value: null,
            join_form: "s1007668.fcurrentmilestone",
            controlType: "text",
            joined_form: [
              {
                join_form: "s1007683.f2fcurrentmilestone",
              },
              {
                join_form: "s1007811.f1fcurrentmilestone",
              },
              {
                join_form: "s1007813.f1fcurrentmilestone",
              },
            ],
            placeholder: "",
          },
          {
            id: "findication",
            max: 100,
            min: 0,
            desc: "",
            label: "适应症",
            value: null,
            join_form: "s1007668.findication",
            controlType: "text",
            joined_form: [
              {
                join_form: "s1007683.f2findication",
              },
              {
                join_form: "s1007811.f1findication",
              },
              {
                join_form: "s1007813.f1findication",
              },
            ],
            placeholder: "",
          },
        ],
        label: "关联他表",
        fields: ["fphase", "fstatus", "fcurrentmilestone", "findication"],
        filters: [],
        form_id: 7668,
        form_type: 2,
        unique_no: "s1007668",
        controlType: "foreign_ref",
        system_type: 1,
      },
    ],
    delete_fieldds: [],
  },
  is_actived: true,
  is_deleted: false,
  deleted_at: "1970-01-01 00:00:00",
  created_at: "2021-12-01 11:48:32",
  updated_at: "2021-12-01 11:48:32",
  unique_no: "s1007816",
  type: 1,
  created_by: 818,
  parse_info: null,
  open_type: 1,
  operator_rule: null,
  data_rule: null,
  createdAt: "2021-12-01 11:48:32",
  updatedAt: "2021-12-01 11:48:32",
})

// let r = formManager.translateExpr("f3")
// console.log(123)
// console.info(r)

// let r1 = formManager.parseExpr('DATE_ADD(单日期,-1,"d,ay")')
// console.info(r1)

// let r2 = formManager.translateExpr("f7")
// console.info(r2)

// let r3 = formManager.parseExpr(
//   'DATE_ADD(DATE_ADD(单日期X, 2, "day"), 2, "day")'
// )
// console.info(r3)

// let r4 = formManager.parseExpr('DATE_ADD(单日期X1, 2, "day")')
// console.info(r4)
// console.info(formManager.getNewRowData())

formManager.bindData([
  { f2: "2020/01/01 00:00:00", f3: "2020/01/01 00:00:00" },
  // { f2: "2020/02/01 00:00:00" },
  // { f2: "2021/01/01 00:00:00" },
])
console.info(formManager.getData())
// console.info(formManager.setFieldValue(0, "f4", "2020/01/03 00:00:00"))

// r = formManager.setFieldValue(0, { f2: new Date() })
// console.info(r)
// r = formManager.getNewRowData()
// console.info(r)
