const { COMPONENT_TYPE } = require("../src/lib/base/component_type");
const ia_parser = require("../src/lib/Intelligence-analyse/parse");
const fs = require('fs');
const path = require('path');

function saveSql (table, sql) {
  sql = sql.replace(/\:current_company_id/g, '1').replace(/\:hour_begin_date/g, '\'2021-08-08 00:00:00\'')
    .replace(/\:hour_end_date/g, '\'2021-08-14 23:59:59\'');
  table.parse_info = table.parse_info || {};
  table.parse_info.sql = sql;
  fs.writeFileSync(path.resolve(__dirname, `./tmp/${table.key}.sql`), sql);
}

const table1 = {
  id: 1,
  key: 's1',
  label: '办事处',
  setting: {
    fields: [
      { id: 'fid', label: 'id', controlType: COMPONENT_TYPE.NUMBER, shown: false, },
      { id: 'f1', label: '部门名称', expr: 'swide_department.fdepartment_name', controlType: COMPONENT_TYPE.TEXT },
      { id: 'f2', label: '人员名称', expr: 'swide_department.fuser_name', dataType: COMPONENT_TYPE.NUMBER, controlType: COMPONENT_TYPE.MATH_FORMULA },
      { id: 'f3', label: '计划工时', expr: 'SUM(swide_department.fproject_plan_time)', dataType: COMPONENT_TYPE.NUMBER, controlType: COMPONENT_TYPE.MATH_FORMULA },
      { id: 'f4', label: '实际工时', expr: 'SUM(swide_department.factual_time)', dataType: COMPONENT_TYPE.NUMBER, controlType: COMPONENT_TYPE.MATH_FORMULA },
    ],
    conditionMap: {
    }
  },
  parse_info: {
  }
};
// let sql = ia_parser.parseIAConfigToSql(table1.setting, [])
// saveSql(table1, sql);

const table2 = {
  id: 1,
  key: 's2',
  label: '办事处1',
  setting: {
    "fields": [
      {
        "id": "fid",
        "label": "id",
        "shown": false,
        "controlType": "number"
      },
      {
        "id": "f1",
        "expr": "swide_department.fdepartment_name",
        "label": "部门名称",
        "shown": true,
        "expr_id": "swide_department.fdepartment_name",
        "fieldId": "swide_department",
        "key_field": "fdepartment_name_key",
        "parent_id": "swide_department",
        "expr_label": "部门.部门名称",
        "controlType": "DEPARTMENT"
      },
      {
        "id": "f2",
        "expr": "swide_department.fuser_name",
        "label": "人员姓名",
        "shown": true,
        "expr_id": "swide_department.fuser_name",
        "fieldId": "swide_department",
        "key_field": "fuser_name_key",
        "parent_id": "swide_department",
        "expr_label": "部门.人员姓名",
        "controlType": "USER"
      },
      {
        "id": "f3",
        "expr": "swide_department.fproject_count",
        "label": "项目数",
        "shown": true,
        "expr_id": "swide_department.fproject_count",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.项目数",
        "controlType": "number"
      },
      {
        "id": "f4",
        "expr": "swide_department.fchild_project_count",
        "label": "中心数",
        "shown": true,
        "expr_id": "swide_department.fchild_project_count",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.中心数",
        "controlType": "number"
      },
      {
        "id": "f5",
        "expr": "swide_department.fproject_seq_no",
        "group": "project",
        "label": "项目编号",
        "shown": true,
        "expr_id": "swide_department.fproject_seq_no",
        "fieldId": "swide_department",
        "key_field": "fproject_seq_no_key",
        "parent_id": "swide_department",
        "dataSource": {
          "url": "",
          "type": "API",
          "method": "getProjectSelect",
          "params": {},
          "result": {
            "id_key": "id",
            "value_key": "seq_no"
          }
        },
        "expr_label": "部门.项目编号",
        "controlType": "select"
      },
      {
        "id": "f6",
        "expr": "swide_department.fproject_current_milestone",
        "label": "项目阶段",
        "shown": true,
        "expr_id": "swide_department.fproject_current_milestone",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.项目阶段",
        "controlType": "text"
      },
      {
        "id": "f7",
        "expr": "swide_department.fproduct_name",
        "label": "产品名称",
        "shown": true,
        "expr_id": "swide_department.fproduct_name",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.产品名称",
        "controlType": "text"
      },
      {
        "id": "f8",
        "expr": "swide_department.findication_comment",
        "label": "适应症",
        "shown": true,
        "expr_id": "swide_department.findication_comment",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.适应症",
        "controlType": "text"
      },
      {
        "id": "f9",
        "expr": "swide_department.fchild_project_name",
        "label": "中心名称",
        "shown": true,
        "expr_id": "swide_department.fchild_project_name",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.中心名称",
        "controlType": "text"
      },
      {
        "id": "f10",
        "expr": "swide_department.fchild_project_current_milestone",
        "label": "中心阶段",
        "shown": true,
        "expr_id": "swide_department.fchild_project_current_milestone",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.中心阶段",
        "controlType": "text"
      },
      {
        "id": "f14",
        "expr": "SUM(swide_department.fchild_project_standard_time)",
        "unit": {
          "prefix": 2
        },
        "label": "中心标准工时",
        "parser": 1,
        "dataType": "number",
        "expr_label": "SUM(部门.中心标准工时)",
        "controlType": "autocalc",
        "functionType": "customize"
      },
      {
        "id": "f15",
        "expr": "SUM(swide_department.fchild_project_plan_time)",
        "unit": {
          "prefix": 2
        },
        "label": "中心计划工时",
        "parser": 1,
        "dataType": "number",
        "expr_label": "SUM(部门.中心计划工时)",
        "controlType": "autocalc",
        "functionType": "customize"
      },
      {
        "id": "f16",
        "expr": "SUM(swide_department.fchild_project_actual_time)",
        "unit": {
          "prefix": 2
        },
        "label": "中心实际工时",
        "parser": 1,
        "dataType": "number",
        "expr_label": "SUM(部门.中心实际工时)",
        "controlType": "autocalc",
        "functionType": "customize"
      },
      {
        "id": "f11",
        "expr": "swide_department.fstandard_time",
        "label": "标准工时",
        "shown": true,
        "expr_id": "swide_department.fstandard_time",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.标准工时",
        "controlType": "number"
      },
      {
        "id": "f12",
        "expr": "swide_department.fplan_time",
        "label": "计划工时",
        "shown": true,
        "expr_id": "swide_department.fplan_time",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.计划工时",
        "controlType": "number"
      },
      {
        "id": "f13",
        "expr": "swide_department.factual_time",
        "label": "实际工时",
        "shown": true,
        "expr_id": "swide_department.factual_time",
        "fieldId": "swide_department",
        "parent_id": "swide_department",
        "expr_label": "部门.实际工时",
        "controlType": "number"
      }
    ],
    "conditionMap": {
      "f1": [
        [
          [
            "f1",
            "=",
            {
              "id": 57,
              "value": "北京办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 61,
              "value": "南京办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 67,
              "value": "沈阳办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 174,
              "value": "合肥办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 175,
              "value": "天津办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 105,
              "value": "华北战区"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 59,
              "value": "重庆办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 90,
              "value": "成都办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 157,
              "value": "西安办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 106,
              "value": "华西战区"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 58,
              "value": "石家庄办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 114,
              "value": "石家庄战区"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 60,
              "value": "长沙办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 62,
              "value": "广州办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 63,
              "value": "武汉办"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 115,
              "value": "武汉战区"
            }
          ]
        ],
        [
          [
            "f1",
            "=",
            {
              "id": 10,
              "value": "RMCC (CRA)"
            }
          ]
        ]
      ],
      "hour_begin_date": "2021-08-22 00:00:00",
      "hour_end_date": "2021-08-28 00:00:00"
    }
  },
  parse_info: {
  }
};
sql = ia_parser.parseIAConfigToSql(table2.setting, [], { enableLimit: true })
saveSql(table2, sql);
